function X = sumofcoeff(mu,varargin)
% SUMOFCOFF  Doan et al's sum-of-coefficient prior dummy observations for BVARs.

% The IRIS Toolbox.
% Copyright 2007-2010 Jaromir Benes.

g = 0;
if length(varargin) == 1
   % BVAR.sumofcoeff(mu,[ny,p]);
   ny = varargin{1}(1);
   p = varargin{1}(2);
   if length(varargin{1}) > 2
       g = varargin{1}(3):
   end
else
   % Bkw compatibility.
   % BVAR.sumofcoeff(mu,ny,p);
   ny = varargin{1};
   p = varargin{2};
   if length(varargin) > 2
      g = varargin{3};
   end
end

P = inputParser();
P.addRequired('mu',@isnumericscalar);
P.addRequired('ny',@isnumericscalar);
P.addRequired('p',@isnumericscalar);
P.addRequired('g',@isnumericscalar);
P.parse(mu,ny,p,g);

%********************************************************************
% Function body.

nd = ny;
k = zeros([1,nd]);
g1 = zeros([g,nd]);
y0 = eye(ny);
y1 = repmat(y0,[p,1]);
X = [y0*mu;k;y1*mu;g1];

end
% End of primary function.