function X = uncmean(ybar,mu,varargin)
% UNCMEAN  Unconditional mean dummy observations for BVARs. Equivalent to
% Sims' initial dummy observations.

% The IRIS Toolbox.
% Copyright 2007-2010 Jaromir Benes.

g = 0;
if length(varargin) == 1
   % BVAR.uncmean(ybar,mu,[ny,p]);
   % BVAR.uncmean(ybar,mu,[ny,p,g]);
   ny = varargin{1}(1);
   p = varargin{1}(2);
   if length(varargin{1}) > 2
      g = varargin{1}(3);
   end
else
   % Bkw compatibility.
   % BVAR.uncmean(ybar,mu,ny,p).
   % BVAR.uncmean(ybar,mu,ny,p,g).
   ny = varargin{1};
   p = varargin{2};
   if length(varargin) > 2
      g = varargin{3};
   end
end

P = inputParser();
P.addRequired('ybar',@isnumeric);
P.addRequired('mu',@isnumericscalar);
P.addRequired('ny',@isnumericscalar);
P.addRequired('p',@isnumericscalar);
P.addRequired('g',@isnumericscalar);
P.parse(ybar,mu,ny,p,g);

if ny ~= numel(ybar)
   error('iris:BVAR', ...
      'Number of variables in the VAR must match the length of the vector of prior means.');
end

%**************************************************************************
% Function body.

ybar = ybar(:);
k1 = mu;
g1 = zeros([g,1]);
X = [ybar*mu;k1;repmat(ybar*mu,[p,1]);g1];

end
% End of primary function.