function pdffile = compilepdf(inputfile,varargin)
% COMPILEPDF  Compile PDF from latex file.

% The IRIS Toolbox 2009/07/03.
% Copyright 2007-2009 Jaromir Benes.

default = {...
  'display',true,@islogical,...
  'rerun',0,@isnumeric,...
};
%  'papersize','a4',@(x) any(strcmpi(x,{'a4','letter','executive'})),...
%  'orientation','portrait',@(x) any(strcmpi(x,{'portrait','landscape'})),...
options = passvalopt(default,varargin{:});

%********************************************************************
% Function body..

thisdir = cd();

config = irisget();
if isempty(config.pdflatexpath)
   error('iris:latex',...
      'PDFLATEX path unknown. Cannot compile PDF files.');
end

[inputpath,inputtitle] = fileparts(inputfile);

cd(inputpath);
inputpath = cd();
cd(thisdir);

display = '';
if ~options.display
   display = ' -quiet';
end
command = ['"',config.pdflatexpath,'" --halt-on-error',display,' "',inputtitle,'"'];
cd(inputpath);
system(command);
for i = 1 : options.rerun
   system(command);
end
pdffile = fullfile(inputpath,[inputtitle,'.pdf']);
fprintf('\n');

cd(thisdir);

end
% End of primary function.