function epstopdf(list,commandoptions,varargin)
% EPSTOPDF  Run TeX's EPSTOPDF to convert EPS to PDF.

% The IRIS Toolbox 2009/11/18.
% Copyright 2007-2009 Jaromir Benes.

default = {...
   'display',false,@islogical,...
};
options = passvalopt(default,varargin{:});

%********************************************************************
% Function body.

if nargin == 1
   commandoptions = '--enlarge=10';
end

if ischar(list)
   list = charlist2cellstr(list);
end

thisdir = cd();
epstopdf = irisget('epstopdfpath');
if isempty(epstopdf)
   error('iris:latex',...
   'EPSTOPDF path unknown. Cannot convert EPS to PDF files.');
end

for i = 1 : length(list)
   [fpath,ftitle,fext] = fileparts(list{i});
   fpath = strtrim(fpath);
   if ~isempty(fpath)
      cd(fpath);
   end
   tmp = dir([ftitle,fext]);
   tmp([tmp.isdir]) = [];
   for j = 1 : length(tmp)
      if options.display
         fprintf('Converting \% to PDF.\n',fullfile(fpath,tmp(j).name));
      end
      system(['"',epstopdf,'" ',tmp(j).name,' ',commandoptions]);
   end
   cd(thisdir);
end

end
% End of primary function.
