classdef includeobj < report.genericobj

   properties
      filename = '';
   end
   
   methods

      function this = includeobj(varargin)
         this = this@report.genericobj(varargin{:});
         this.accept = {};
         this.default = { ...
            'lines',Inf,@isnumeric,true, ...
            'verbatim',false,@islogicalscalar,false, ...
            'separator','',@ischar,false, ...            
         };
      end
      
      function [this,varargin] = specargin(this,varargin)
         if ~isempty(varargin)
            this.filename = varargin{1};
            varargin(1) = [];
         end         
      end
      
      function [c,helperfiles] = latexcode(this,parent)
         helperfiles = {};
         nl= sprintf('\n');
         c = ['{\large \bfseries ',latex.stringsubs(this.caption),'}',nl];
         if this.options.verbatim
            file = file2char(this.filename,'char',this.options.lines);
            file = strfun.converteols(file);
            c = [c,'\begin{verbatim}',nl];
            c = [c,file,nl];
            c = [c,'\end{verbatim}%',nl];
         else
            c = [c,'{%',nl];
            c = [c,'\input{',this.filename,'}%',nl];
            c = [c,'}%',nl];
         end
      end
      
   end
   
end