classdef reportobj < report.genericobj

   methods

      function this = reportobj(varargin)
         this = this@report.genericobj(varargin{:});
         this.accept = {'section','table','figure','matrix',...
            'text','clearpage','include'};
         this.default = {...
            'centering',true,@islogical,false,...
         };
      end
      
      function [c,helperfiles] = latexcode(this)
         nl = sprintf('\n');
         c = '';
         if this.options.centering
            c = [c,'\centering',nl,nl];
         end
         helperfiles = {};
         for i = 1 : this.nChildren
            %c = [c,'{%',nl];
            c = [c,nl];
            [c1,tmphelperfiles] = latexcode(this.children{i},this);
            c = [c,c1,'%',nl];
            helperfiles = [helperfiles,tmphelperfiles];
            %c = [c,'}%',nl];
            c = [c,nl];
            if i < this.nChildren
               c = [c,this.children{i}.options.separator,nl];
            end
         end
      end
      
   end

end