classdef subheadingobj < report.genericobj

   properties
      series = [];
   end
   
   methods

      function this = subheadingobj(varargin)
         this = this@report.genericobj(varargin{:});
         this.accept = {};
         this.default = {...
            'justify','left',@(x) any(strcmpi(x,{'left','centre','center'})),true, ...
         };         
      end
      
      function [this,varargin] = specargin(this,varargin)
      end
      
      function c = latexcode(this,parent)
         vline = parent.options.vline;
         vline(vline < parent.range(1)-1 | vline > parent.range(end)) = [];
         vline = min(vline);
         isvline = ~isempty(vline);
         if strncmpi(this.options.justify,'l',1) && isvline
            NofColumns = parent.nLeading + round(vline - parent.range(1));
         else
            NofColumns = parent.nColumns;
         end
         c = '\multicolumn{!NofColumns}{!Justify!VLine}{\itshape\bfseries !Caption} !EmptyCols \\';
         %if isvline
         %   c = strrep(c,'!VLine','|');
         %else
            c  = strrep(c,'!VLine','');
         %end
         c = strrep(c,'!Justify',lower(this.options.justify(1)));
         c = strrep(c,'!NofColumns',sprintf('%g',NofColumns));
         c = strrep(c,'!Caption',latex.stringsubs(this.caption));
         c = strrep(c,'!EmptyCols',repmat('& ',[1,parent.nColumns-NofColumns]));
      end
      
   end   

end