classdef textobj < report.genericobj

   properties
      text = '';
   end
   
   methods

      function this = textobj(varargin)
         this = this@report.genericobj(varargin{:});
         this.accept = {};
         this.default = { ...
            'separator','\medskip\par',@ischar,true, ...
            'verbatim',false,@islogicalscalar,true, ...
         };
         % Grab text from caller.
         caller = dbstack('-completenames');
         if length(caller) >= 3
            this = this.grabtext(caller(3));
         end
      end
      
      function [this,varargin] = specargin(this,varargin)
      end
      
      function [c,helperfiles] = latexcode(this,parent)
         helperfiles = {};
         if isempty(this.text)
            c = '';
            return
         end
         nl = sprintf('\n');
         c = ['{\large\bfseries ', ...
            latex.stringsubs(this.caption), ...
            '}\par',nl,nl];
         if this.options.verbatim
            c = [c,'\begin{verbatim}',nl];
         else
            c = [c,'\begin{flushleft}',nl];
         end
         c = [c,this.text];
         if this.options.verbatim
            c = [c,'\end{verbatim}',nl];
         else
            c = [c,'\end{flushleft}',nl];
         end
      end
      
   end

   methods (Access = 'private')
      
      function this = grabtext(this,caller)
         c = file2char(caller.file,'cellstrs');
         c = [c{caller.line+1:end}];
         c = strfun.converteols(c);
         tokens = regexp(c,'^[ \t]*%\{[ \t]*$(.*?)^[ \t]*%\}[ \t]*$', ...
            'tokens','once','lineanchors');
         if ~isempty(tokens)
            this.text = tokens{1};
         else
            this.text = '';
         end
      end
      
   end
   
end