function [F,di] = factorise(C)

[nx,nx,nalt] = size(C);
F = nan(size(C));
di = nan([1,nalt]);

for i = 1 : nalt
   try
      F(:,:,i) = chol(C(:,:,i)).';
   catch
      [U,S] = svd(C(:,:,i));
      S = diag(S).';
      S(S < 0) = 0;
      S = sqrt(S);
      F(:,:,i) = U .* S(ones([1,nx]),:);
   end
   if nargout > 1
      di(i) = maxabs(C - F*F.');
   end
end

end