function X = fmse(T,R,K,Z,H,D,U,Omega,nper)
%
% TIME-DOMAIN/FMSE  Forecast mean square error matrices for general state space.
%
% The IRIS Toolbox 2007/08/23. Copyright 2007 Jaromir Benes. <a href="http://www.iris-toolbox.com">www.iris-toolbox.com</a>

%**************************************************************************
% Function body.

ny = size(Z,1);
[nx,nb] = size(T);
nf = nx - nb;
ne = size(R,2);
n = ny + nf + nb;

% Compute VMA representation.
Phi = time_domain.srf(T,R,K,Z,H,D,U,Omega,nper);

X = nan([n,n,nper]);
for t = 1 : nper
   X(:,:,t) = Phi(:,:,t)*Omega*transpose(Phi(:,:,t));
end
X = cumsum(X,3);

end
% End of primary function.