function [Py,Pfa,Pe] = simulatemse(T,R,K,Z,H,D,U,varvec,initmse,nper)
% SIMULATEMSE  Simulate MSE matrices in general state space.

% The IRIS Toolbox 2009/06/23.
% Copyright 2007-2009 Jaromir Benes.

%********************************************************************
% Function body..

symm = @(X) (X + X')/2;

[nx,nb] = size(T);
[ny,ne] = size(H); 
nf = nx - nb;

Py = nan([ny,ny,nper]);
Pfa = nan([nx,nx,nper]);
Pe = nan([ne,ne,nper]);
for t = 1 : nper
   Pe(:,:,t) = diag(varvec(:,t));
   Pesparse = sparse(Pe(:,:,t));
   Sigmax = symm(R(:,1:ne)*Pesparse*R(:,1:ne)');
   Sigmay = symm(H*Pesparse*H');
   if t == 1
      if isempty(initmse) || all(all(initmse == 0))
         Pfa(:,:,t) = Sigmax;
      else
         Pfa(:,:,t) = symm(T*initmse*T' + Sigmax);
      end
   else
      Pfa(:,:,t) = symm(T*Pfa(nf+1:end,nf+1:end,t-1)*T' + Sigmax);
   end
   Py(:,:,t) = symm(Z*Pfa(nf+1:end,nf+1:end,t)*Z' + Sigmay);
end

end
% End of primary function.