function [P,discrep,exitflag] = SPBC_sstate(P,varargin)
% Steady-state file based on |SPBC_sstate.s|.
% Automatically generated by The IRIS Toolbox, 09-Apr-2010 11:15:02.

nblock = 4;
optim = optimset(varargin{:});
input = {'beta','eta','gamma','pie'};

if ismodel(P)
   outputformat = 'model';
   m = P;
   P = struct();
   for i = 1 : length(input)
      P.(input{i}) = m.(input{i});
   end
else
   outputformat = 'dbase';
end

[P,nalt] = getmaxlength(P,input);
discrep = cell([1,nblock]);
discrep(:) = {cell([1,nalt])};
exitflag = cell([1,nblock]);
exitflag(:) = {nan([1,nalt])};
for i = 1 : nalt
   P = block1(P,i);
   [P,discrep{2}{i},exitflag{2}(i)] = block2(P,i,optim);
   P = block3(P,i);
   P = block4(P,i);
end

if strcmpi(outputformat,'model')
   P = assign(m,P);
end

end


%**************************************************************************
function varargout = block1(varargin)
try
   beta = varargin{1}.beta(varargin{2});
end
try
   eta = varargin{1}.eta(varargin{2});
end
try
   gamma = varargin{1}.gamma(varargin{2});
end
try
   pie = varargin{1}.pie(varargin{2});
end
dp=pie;
dp4=pie;
dw=pie;
r=(1+dp)/beta-1;
g=0;
A=1;
gamma_=gamma;
varargout{1} = varargin{1};
varargout{1}.dp(1,varargin{2}) = dp;
varargout{1}.dp4(1,varargin{2}) = dp4;
varargout{1}.dw(1,varargin{2}) = dw;
varargout{1}.r(1,varargin{2}) = r;
varargout{1}.g(1,varargin{2}) = g;
varargout{1}.A(1,varargin{2}) = A;
varargout{1}.gamma_(1,varargin{2}) = gamma_;
end

%**************************************************************************
function varargout = block2(varargin)
try
   beta = varargin{1}.beta(varargin{2});
end
try
   eta = varargin{1}.eta(varargin{2});
end
try
   gamma = varargin{1}.gamma(varargin{2});
end
try
   pie = varargin{1}.pie(varargin{2});
end
try
   dp = varargin{1}.dp(varargin{2});
end
try
   dp4 = varargin{1}.dp4(varargin{2});
end
try
   dw = varargin{1}.dw(varargin{2});
end
try
   r = varargin{1}.r(varargin{2});
end
try
   g = varargin{1}.g(varargin{2});
end
try
   A = varargin{1}.A(varargin{2});
end
try
   gamma_ = varargin{1}.gamma_(varargin{2});
end
X__ = zeros([1,4]);
try 
  X__(1) = log(varargin{1}.Y(1,varargin{2}));
catch
   try
     X__(1) = log(varargin{1}.Y(1,varargin{2}-1));
   end
end
try 
  X__(2) = log(varargin{1}.C(1,varargin{2}));
catch
   try
     X__(2) = log(varargin{1}.C(1,varargin{2}-1));
   end
end
try 
  X__(3) = log(varargin{1}.Q(1,varargin{2}));
catch
   try
     X__(3) = log(varargin{1}.Q(1,varargin{2}-1));
   end
end
try 
  X__(4) = log(varargin{1}.L(1,varargin{2}));
catch
   try
     X__(4) = log(varargin{1}.L(1,varargin{2}-1));
   end
end
varargout{1} = varargin{1};
[X__,varargout{2},varargout{3}] = fsolve(@solve__,X__,varargin{3});
varargout{1}.Y(1,varargin{2}) = exp(X__(1));
varargout{1}.C(1,varargin{2}) = exp(X__(2));
varargout{1}.Q(1,varargin{2}) = exp(X__(3));
varargout{1}.L(1,varargin{2}) = exp(X__(4));
	function varargout = solve__(varargin)
	Y = exp(varargin{1}(1));
	C = exp(varargin{1}(2));
	Q = exp(varargin{1}(3));
	L = exp(varargin{1}(4));
	varargout{1} = [
	Q-(L^eta*C)
	Y-(L^gamma_)
	gamma_*Y/L-(Q)
	Y-(C)
	];
	end
end

%**************************************************************************
function varargout = block3(varargin)
try
   beta = varargin{1}.beta(varargin{2});
end
try
   eta = varargin{1}.eta(varargin{2});
end
try
   gamma = varargin{1}.gamma(varargin{2});
end
try
   pie = varargin{1}.pie(varargin{2});
end
try
   dp = varargin{1}.dp(varargin{2});
end
try
   dp4 = varargin{1}.dp4(varargin{2});
end
try
   dw = varargin{1}.dw(varargin{2});
end
try
   r = varargin{1}.r(varargin{2});
end
try
   g = varargin{1}.g(varargin{2});
end
try
   A = varargin{1}.A(varargin{2});
end
try
   gamma_ = varargin{1}.gamma_(varargin{2});
end
try
   Y = varargin{1}.Y(varargin{2});
end
try
   C = varargin{1}.C(varargin{2});
end
try
   Q = varargin{1}.Q(varargin{2});
end
try
   L = varargin{1}.L(varargin{2});
end
MUC=1/C;
MDL=L^eta;
MPL=(1-gamma_)*Y/L;
varargout{1} = varargin{1};
varargout{1}.MUC(1,varargin{2}) = MUC;
varargout{1}.MDL(1,varargin{2}) = MDL;
varargout{1}.MPL(1,varargin{2}) = MPL;
end

%**************************************************************************
function varargout = block4(varargin)
try
   beta = varargin{1}.beta(varargin{2});
end
try
   eta = varargin{1}.eta(varargin{2});
end
try
   gamma = varargin{1}.gamma(varargin{2});
end
try
   pie = varargin{1}.pie(varargin{2});
end
try
   dp = varargin{1}.dp(varargin{2});
end
try
   dp4 = varargin{1}.dp4(varargin{2});
end
try
   dw = varargin{1}.dw(varargin{2});
end
try
   r = varargin{1}.r(varargin{2});
end
try
   g = varargin{1}.g(varargin{2});
end
try
   A = varargin{1}.A(varargin{2});
end
try
   gamma_ = varargin{1}.gamma_(varargin{2});
end
try
   Y = varargin{1}.Y(varargin{2});
end
try
   C = varargin{1}.C(varargin{2});
end
try
   Q = varargin{1}.Q(varargin{2});
end
try
   L = varargin{1}.L(varargin{2});
end
try
   MUC = varargin{1}.MUC(varargin{2});
end
try
   MDL = varargin{1}.MDL(varargin{2});
end
try
   MPL = varargin{1}.MPL(varargin{2});
end
r_=r;
dp_=dp;
Y_=Y;
Q_=Q;
varargout{1} = varargin{1};
varargout{1}.r_(1,varargin{2}) = r_;
varargout{1}.dp_(1,varargin{2}) = dp_;
varargout{1}.Y_(1,varargin{2}) = Y_;
varargout{1}.Q_(1,varargin{2}) = Q_;
end

%**************************************************************************
function [P,maxlength] = getmaxlength(P,list)
nlist = numel(list);
n = nan([1,nlist]);
for i = 1 : nlist
   try
      P.(list{i}) = transpose(P.(list{i})(:));
      n(i) = length(P.(list{i}));
   end
end
maxlength = max([1,n(~isnan(n))]);
index = 1 : nlist;
index(n == maxlength) = [];
for i = index
   try
      P.(list{i}) = ...
         [P.(list{i}),P.(list{i})(end)*ones([1,maxlength-n(i)])];
   end
end
end