% Sticky-price sticky-wage business cycle model.
% Steady-state code file.

!parameters

   beta, eta, gamma, pie
   
!equations

   dp = pie;
   dp4 = pie;
   dw = pie;
   r = (1 + dp)/beta - 1;
   g = 0;
   A = 1;
   % Cannot use "gamma" in Symbolic Math. Replace with gamma_.
   gamma_ = gamma;
   
!equations

   !symbolic

% Households
   Q = L^eta*C;
      
% Producers
   Y = L^gamma_;
   gamma_*Y/L = Q;
   
% Market clearing
   Y = C;
   
   !solvefor
   Y, C, Q, L
   
   !variables:positive
   !allbut

!equations

   MUC = 1/C;
   MDL = L^eta;
   MPL = (1-gamma_)*Y/L;

!equations   
   
   r_ = r;   
   dp_ = dp;
   Y_ = Y;
   Q_ = Q;
   