clear();
close('all');
set(0,'formatSpacing','loose');
load('readModel.mat','m');

m.w = 0;
m.theta = 1;
m = solve(m);

weights = [1,0.5,0.05,0.1,0.5];

ylist = get(m,'ylist');
ylist = regexprep(ylist,'.*','(log $0 - log $0ss)^2: ');
display([char(ylist.'),num2str(weights.')]);

[mo,QQ,WW,Qlist,Wlist,count,YY,LL,discrep] = tcorule(m, ...
   {'O','R'},{'Monetary policy','Macroprudential policy'},weights,...
   'beta',m.beta,'display',500);

d = zerodb(m,-3:40);
d.E(0) = d.E(0)*0.9;
s = simulate(m,d,1:40,'deviation',true);
so = simulate(mo,d,1:40,'deviation',true);

sty = struct();
sty.line.marker = '.';

list = {'100*(GDP-1)','100*(C-1)','100*(I-1)','100*(X-1)','100*(M-1)', ...
   '400*(Rl-1)','400*(R-1)','100*(dP^4-1)', ...
   '100*(S-1)','100*(Pk-1)','100*(Pk1-1)','100*B','100*(Ge-1)', ...
   '100*(L-1)','100*(F-1)','100*(E-1)','100*(L2E-1)','100*(O-1)'};

dbplot(s & so,0:40,list, ...
   'zeroline',true, ...
   'style',sty, ...
   'tight',true);

save('optimalRule.mat');
