function [P,discrep,exitflag] = SOEMOLIv1_sstate(P,varargin)
% Steady-state file based on |SOEMOLIv1_sstate.s|.
% Automatically generated by The IRIS Toolbox, 08-Apr-2010 13:12:43.

nblock = 4;
optim = optimset(varargin{:});
input = {'alpha','beta','gamman','gammam','delta','eta','nu','pwstar','p','a','t','f2ngdp','g2','g3'};

if ismodel(P)
   outputformat = 'model';
   m = P;
   P = struct();
   for i = 1 : length(input)
      P.(input{i}) = m.(input{i});
   end
else
   outputformat = 'dbase';
end

[P,nalt] = getmaxlength(P,input);
discrep = cell([1,nblock]);
discrep(:) = {cell([1,nalt])};
exitflag = cell([1,nblock]);
exitflag(:) = {nan([1,nalt])};
for i = 1 : nalt
   P = block1(P,i);
   [P,discrep{2}{i},exitflag{2}(i)] = block2(P,i,optim);
   P = block3(P,i);
   P = block4(P,i);
end

if strcmpi(outputformat,'model')
   P = assign(m,P);
end

end


%**************************************************************************
function varargout = block1(varargin)
try
   alpha = varargin{1}.alpha(varargin{2});
end
try
   beta = varargin{1}.beta(varargin{2});
end
try
   gamman = varargin{1}.gamman(varargin{2});
end
try
   gammam = varargin{1}.gammam(varargin{2});
end
try
   delta = varargin{1}.delta(varargin{2});
end
try
   eta = varargin{1}.eta(varargin{2});
end
try
   nu = varargin{1}.nu(varargin{2});
end
try
   pwstar = varargin{1}.pwstar(varargin{2});
end
try
   p = varargin{1}.p(varargin{2});
end
try
   a = varargin{1}.a(varargin{2});
end
try
   t = varargin{1}.t(varargin{2});
end
try
   f2ngdp = varargin{1}.f2ngdp(varargin{2});
end
try
   g2 = varargin{1}.g2(varargin{2});
end
try
   g3 = varargin{1}.g3(varargin{2});
end
G=gfn(0.55,g2,g3);
Ge=G;
Rl=1/beta;
R=Rl*G;
Rstar=R;
Rwstar=Rstar;
Rk=Rl;
Pwstar=pwstar;
P=p;
T=t;
A=a;
U=0;
B=0;
Py=P*(nu-1)/nu;
Pk=P;
Px=Py;
varargout{1} = varargin{1};
varargout{1}.G(1,varargin{2}) = G;
varargout{1}.Ge(1,varargin{2}) = Ge;
varargout{1}.Rl(1,varargin{2}) = Rl;
varargout{1}.R(1,varargin{2}) = R;
varargout{1}.Rstar(1,varargin{2}) = Rstar;
varargout{1}.Rwstar(1,varargin{2}) = Rwstar;
varargout{1}.Rk(1,varargin{2}) = Rk;
varargout{1}.Pwstar(1,varargin{2}) = Pwstar;
varargout{1}.P(1,varargin{2}) = P;
varargout{1}.T(1,varargin{2}) = T;
varargout{1}.A(1,varargin{2}) = A;
varargout{1}.U(1,varargin{2}) = U;
varargout{1}.B(1,varargin{2}) = B;
varargout{1}.Py(1,varargin{2}) = Py;
varargout{1}.Pk(1,varargin{2}) = Pk;
varargout{1}.Px(1,varargin{2}) = Px;
end

%**************************************************************************
function varargout = block2(varargin)
try
   alpha = varargin{1}.alpha(varargin{2});
end
try
   beta = varargin{1}.beta(varargin{2});
end
try
   gamman = varargin{1}.gamman(varargin{2});
end
try
   gammam = varargin{1}.gammam(varargin{2});
end
try
   delta = varargin{1}.delta(varargin{2});
end
try
   eta = varargin{1}.eta(varargin{2});
end
try
   nu = varargin{1}.nu(varargin{2});
end
try
   pwstar = varargin{1}.pwstar(varargin{2});
end
try
   p = varargin{1}.p(varargin{2});
end
try
   a = varargin{1}.a(varargin{2});
end
try
   t = varargin{1}.t(varargin{2});
end
try
   f2ngdp = varargin{1}.f2ngdp(varargin{2});
end
try
   g2 = varargin{1}.g2(varargin{2});
end
try
   g3 = varargin{1}.g3(varargin{2});
end
try
   G = varargin{1}.G(varargin{2});
end
try
   Ge = varargin{1}.Ge(varargin{2});
end
try
   Rl = varargin{1}.Rl(varargin{2});
end
try
   R = varargin{1}.R(varargin{2});
end
try
   Rstar = varargin{1}.Rstar(varargin{2});
end
try
   Rwstar = varargin{1}.Rwstar(varargin{2});
end
try
   Rk = varargin{1}.Rk(varargin{2});
end
try
   Pwstar = varargin{1}.Pwstar(varargin{2});
end
try
   P = varargin{1}.P(varargin{2});
end
try
   T = varargin{1}.T(varargin{2});
end
try
   A = varargin{1}.A(varargin{2});
end
try
   U = varargin{1}.U(varargin{2});
end
try
   B = varargin{1}.B(varargin{2});
end
try
   Py = varargin{1}.Py(varargin{2});
end
try
   Pk = varargin{1}.Pk(varargin{2});
end
try
   Px = varargin{1}.Px(varargin{2});
end
X__ = zeros([1,14]);
try 
  X__(1) = log(varargin{1}.C(1,varargin{2}));
catch
   try
     X__(1) = log(varargin{1}.C(1,varargin{2}-1));
   end
end
try 
  X__(2) = log(varargin{1}.N(1,varargin{2}));
catch
   try
     X__(2) = log(varargin{1}.N(1,varargin{2}-1));
   end
end
try 
  X__(3) = log(varargin{1}.I(1,varargin{2}));
catch
   try
     X__(3) = log(varargin{1}.I(1,varargin{2}-1));
   end
end
try 
  X__(4) = log(varargin{1}.K(1,varargin{2}));
catch
   try
     X__(4) = log(varargin{1}.K(1,varargin{2}-1));
   end
end
try 
  X__(5) = log(varargin{1}.Y(1,varargin{2}));
catch
   try
     X__(5) = log(varargin{1}.Y(1,varargin{2}-1));
   end
end
try 
  X__(6) = log(varargin{1}.X(1,varargin{2}));
catch
   try
     X__(6) = log(varargin{1}.X(1,varargin{2}-1));
   end
end
try 
  X__(7) = log(varargin{1}.M(1,varargin{2}));
catch
   try
     X__(7) = log(varargin{1}.M(1,varargin{2}-1));
   end
end
try 
  X__(8) = log(varargin{1}.Ph(1,varargin{2}));
catch
   try
     X__(8) = log(varargin{1}.Ph(1,varargin{2}-1));
   end
end
try 
  X__(9) = log(varargin{1}.Pm(1,varargin{2}));
catch
   try
     X__(9) = log(varargin{1}.Pm(1,varargin{2}-1));
   end
end
try 
  X__(10) = log(varargin{1}.Q(1,varargin{2}));
catch
   try
     X__(10) = log(varargin{1}.Q(1,varargin{2}-1));
   end
end
try 
  X__(11) = log(varargin{1}.S(1,varargin{2}));
catch
   try
     X__(11) = log(varargin{1}.S(1,varargin{2}-1));
   end
end
try 
  X__(12) = log(varargin{1}.W(1,varargin{2}));
catch
   try
     X__(12) = log(varargin{1}.W(1,varargin{2}-1));
   end
end
try 
  X__(13) = log(varargin{1}.F(1,varargin{2}));
catch
   try
     X__(13) = log(varargin{1}.F(1,varargin{2}-1));
   end
end
try 
  X__(14) = log(varargin{1}.NGDP(1,varargin{2}));
catch
   try
     X__(14) = log(varargin{1}.NGDP(1,varargin{2}-1));
   end
end
varargout{1} = varargin{1};
[X__,varargout{2},varargout{3}] = fsolve(@solve__,X__,varargin{3});
varargout{1}.C(1,varargin{2}) = exp(X__(1));
varargout{1}.N(1,varargin{2}) = exp(X__(2));
varargout{1}.I(1,varargin{2}) = exp(X__(3));
varargout{1}.K(1,varargin{2}) = exp(X__(4));
varargout{1}.Y(1,varargin{2}) = exp(X__(5));
varargout{1}.X(1,varargin{2}) = exp(X__(6));
varargout{1}.M(1,varargin{2}) = exp(X__(7));
varargout{1}.Ph(1,varargin{2}) = exp(X__(8));
varargout{1}.Pm(1,varargin{2}) = exp(X__(9));
varargout{1}.Q(1,varargin{2}) = exp(X__(10));
varargout{1}.S(1,varargin{2}) = exp(X__(11));
varargout{1}.W(1,varargin{2}) = exp(X__(12));
varargout{1}.F(1,varargin{2}) = exp(X__(13));
varargout{1}.NGDP(1,varargin{2}) = exp(X__(14));
	function varargout = solve__(varargin)
	C = exp(varargin{1}(1));
	N = exp(varargin{1}(2));
	I = exp(varargin{1}(3));
	K = exp(varargin{1}(4));
	Y = exp(varargin{1}(5));
	X = exp(varargin{1}(6));
	M = exp(varargin{1}(7));
	Ph = exp(varargin{1}(8));
	Pm = exp(varargin{1}(9));
	Q = exp(varargin{1}(10));
	S = exp(varargin{1}(11));
	W = exp(varargin{1}(12));
	F = exp(varargin{1}(13));
	NGDP = exp(varargin{1}(14));
	varargout{1} = [
	nu/(nu-1)*N^eta*P*C-(W)
	Ph-(1/Rl*(alpha*P*C+(1-delta)*Ph))
	Rk-((Q+(1-delta)*Pk)/Pk)
	I-(delta*K)
	Y-(exp(A)*K^(1-gamman-gammam)*N^gamman*M^gammam)
	gamman*Py*Y-(W*N)
	gammam*Py*Y-(Pm*M)
	(1-gamman-gammam)*Py*Y-(Q*K)
	Pm-(S*Pwstar)
	Px-(exp(T)*S*Pwstar)
	Y-(C+X+I)
	F-(f2ngdp*NGDP)
	F-(F*R-Px*X+Pm*M)
	NGDP-(P*C+P*I+Px*X-Pm*M)
	];
	end
end

%**************************************************************************
function varargout = block3(varargin)
try
   alpha = varargin{1}.alpha(varargin{2});
end
try
   beta = varargin{1}.beta(varargin{2});
end
try
   gamman = varargin{1}.gamman(varargin{2});
end
try
   gammam = varargin{1}.gammam(varargin{2});
end
try
   delta = varargin{1}.delta(varargin{2});
end
try
   eta = varargin{1}.eta(varargin{2});
end
try
   nu = varargin{1}.nu(varargin{2});
end
try
   pwstar = varargin{1}.pwstar(varargin{2});
end
try
   p = varargin{1}.p(varargin{2});
end
try
   a = varargin{1}.a(varargin{2});
end
try
   t = varargin{1}.t(varargin{2});
end
try
   f2ngdp = varargin{1}.f2ngdp(varargin{2});
end
try
   g2 = varargin{1}.g2(varargin{2});
end
try
   g3 = varargin{1}.g3(varargin{2});
end
try
   G = varargin{1}.G(varargin{2});
end
try
   Ge = varargin{1}.Ge(varargin{2});
end
try
   Rl = varargin{1}.Rl(varargin{2});
end
try
   R = varargin{1}.R(varargin{2});
end
try
   Rstar = varargin{1}.Rstar(varargin{2});
end
try
   Rwstar = varargin{1}.Rwstar(varargin{2});
end
try
   Rk = varargin{1}.Rk(varargin{2});
end
try
   Pwstar = varargin{1}.Pwstar(varargin{2});
end
try
   P = varargin{1}.P(varargin{2});
end
try
   T = varargin{1}.T(varargin{2});
end
try
   A = varargin{1}.A(varargin{2});
end
try
   U = varargin{1}.U(varargin{2});
end
try
   B = varargin{1}.B(varargin{2});
end
try
   Py = varargin{1}.Py(varargin{2});
end
try
   Pk = varargin{1}.Pk(varargin{2});
end
try
   Px = varargin{1}.Px(varargin{2});
end
try
   C = varargin{1}.C(varargin{2});
end
try
   N = varargin{1}.N(varargin{2});
end
try
   I = varargin{1}.I(varargin{2});
end
try
   K = varargin{1}.K(varargin{2});
end
try
   Y = varargin{1}.Y(varargin{2});
end
try
   X = varargin{1}.X(varargin{2});
end
try
   M = varargin{1}.M(varargin{2});
end
try
   Ph = varargin{1}.Ph(varargin{2});
end
try
   Pm = varargin{1}.Pm(varargin{2});
end
try
   Q = varargin{1}.Q(varargin{2});
end
try
   S = varargin{1}.S(varargin{2});
end
try
   W = varargin{1}.W(varargin{2});
end
try
   F = varargin{1}.F(varargin{2});
end
try
   NGDP = varargin{1}.NGDP(varargin{2});
end
L=F;
Lambda=1/(P*C);
Se=S;
V=1;
Pk1=Pk;
Rk1=Rk;
g1=0.55*Rk*Pk*K/(Rl*L);
GDP=exp(P*C/NGDP*log(C)+P*I/NGDP*log(I)+Px*X/NGDP*log(X)-Pm*M/NGDP*log(M));
dP=1;
dW=1;
dPwstar=1;
d4P=1;
varargout{1} = varargin{1};
varargout{1}.L(1,varargin{2}) = L;
varargout{1}.Lambda(1,varargin{2}) = Lambda;
varargout{1}.Se(1,varargin{2}) = Se;
varargout{1}.V(1,varargin{2}) = V;
varargout{1}.Pk1(1,varargin{2}) = Pk1;
varargout{1}.Rk1(1,varargin{2}) = Rk1;
varargout{1}.g1(1,varargin{2}) = g1;
varargout{1}.GDP(1,varargin{2}) = GDP;
varargout{1}.dP(1,varargin{2}) = dP;
varargout{1}.dW(1,varargin{2}) = dW;
varargout{1}.dPwstar(1,varargin{2}) = dPwstar;
varargout{1}.d4P(1,varargin{2}) = d4P;
end

%**************************************************************************
function varargout = block4(varargin)
try
   alpha = varargin{1}.alpha(varargin{2});
end
try
   beta = varargin{1}.beta(varargin{2});
end
try
   gamman = varargin{1}.gamman(varargin{2});
end
try
   gammam = varargin{1}.gammam(varargin{2});
end
try
   delta = varargin{1}.delta(varargin{2});
end
try
   eta = varargin{1}.eta(varargin{2});
end
try
   nu = varargin{1}.nu(varargin{2});
end
try
   pwstar = varargin{1}.pwstar(varargin{2});
end
try
   p = varargin{1}.p(varargin{2});
end
try
   a = varargin{1}.a(varargin{2});
end
try
   t = varargin{1}.t(varargin{2});
end
try
   f2ngdp = varargin{1}.f2ngdp(varargin{2});
end
try
   g2 = varargin{1}.g2(varargin{2});
end
try
   g3 = varargin{1}.g3(varargin{2});
end
try
   G = varargin{1}.G(varargin{2});
end
try
   Ge = varargin{1}.Ge(varargin{2});
end
try
   Rl = varargin{1}.Rl(varargin{2});
end
try
   R = varargin{1}.R(varargin{2});
end
try
   Rstar = varargin{1}.Rstar(varargin{2});
end
try
   Rwstar = varargin{1}.Rwstar(varargin{2});
end
try
   Rk = varargin{1}.Rk(varargin{2});
end
try
   Pwstar = varargin{1}.Pwstar(varargin{2});
end
try
   P = varargin{1}.P(varargin{2});
end
try
   T = varargin{1}.T(varargin{2});
end
try
   A = varargin{1}.A(varargin{2});
end
try
   U = varargin{1}.U(varargin{2});
end
try
   B = varargin{1}.B(varargin{2});
end
try
   Py = varargin{1}.Py(varargin{2});
end
try
   Pk = varargin{1}.Pk(varargin{2});
end
try
   Px = varargin{1}.Px(varargin{2});
end
try
   C = varargin{1}.C(varargin{2});
end
try
   N = varargin{1}.N(varargin{2});
end
try
   I = varargin{1}.I(varargin{2});
end
try
   K = varargin{1}.K(varargin{2});
end
try
   Y = varargin{1}.Y(varargin{2});
end
try
   X = varargin{1}.X(varargin{2});
end
try
   M = varargin{1}.M(varargin{2});
end
try
   Ph = varargin{1}.Ph(varargin{2});
end
try
   Pm = varargin{1}.Pm(varargin{2});
end
try
   Q = varargin{1}.Q(varargin{2});
end
try
   S = varargin{1}.S(varargin{2});
end
try
   W = varargin{1}.W(varargin{2});
end
try
   F = varargin{1}.F(varargin{2});
end
try
   NGDP = varargin{1}.NGDP(varargin{2});
end
try
   L = varargin{1}.L(varargin{2});
end
try
   Lambda = varargin{1}.Lambda(varargin{2});
end
try
   Se = varargin{1}.Se(varargin{2});
end
try
   V = varargin{1}.V(varargin{2});
end
try
   Pk1 = varargin{1}.Pk1(varargin{2});
end
try
   Rk1 = varargin{1}.Rk1(varargin{2});
end
try
   g1 = varargin{1}.g1(varargin{2});
end
try
   GDP = varargin{1}.GDP(varargin{2});
end
try
   dP = varargin{1}.dP(varargin{2});
end
try
   dW = varargin{1}.dW(varargin{2});
end
try
   dPwstar = varargin{1}.dPwstar(varargin{2});
end
try
   d4P = varargin{1}.d4P(varargin{2});
end
PxX2NGDP=Px*X/NGDP;
PmM2NGDP=Pm*M/NGDP;
PC2NGDP=P*C/NGDP;
WN2NGDP=W*N/NGDP;
PkK2NGDP=Pk*K/NGDP;
PI2NGDP=P*I/NGDP;
F2NGDP=F/NGDP;
varargout{1} = varargin{1};
varargout{1}.PxX2NGDP(1,varargin{2}) = PxX2NGDP;
varargout{1}.PmM2NGDP(1,varargin{2}) = PmM2NGDP;
varargout{1}.PC2NGDP(1,varargin{2}) = PC2NGDP;
varargout{1}.WN2NGDP(1,varargin{2}) = WN2NGDP;
varargout{1}.PkK2NGDP(1,varargin{2}) = PkK2NGDP;
varargout{1}.PI2NGDP(1,varargin{2}) = PI2NGDP;
varargout{1}.F2NGDP(1,varargin{2}) = F2NGDP;
end

%**************************************************************************
function [P,maxlength] = getmaxlength(P,list)
nlist = numel(list);
n = nan([1,nlist]);
for i = 1 : nlist
   try
      P.(list{i}) = transpose(P.(list{i})(:));
      n(i) = length(P.(list{i}));
   end
end
maxlength = max([1,n(~isnan(n))]);
index = 1 : nlist;
index(n == maxlength) = [];
for i = index
   try
      P.(list{i}) = ...
         [P.(list{i}),P.(list{i})(end)*ones([1,maxlength-n(i)])];
   end
end
end