function [P,discrep,exitflag] = SOEMOLIvFA_sstate(P,varargin)
% Steady-state file based on |SOEMOLIvFA_sstate.s|.
% Automatically generated by The IRIS Toolbox, 07-Apr-2010 14:05:49.

nblock = 5;
optim = optimset(varargin{:});
input = {'sigma','mu','k2e','beta','gamman','gammam','delta','eta','nu','pwstar','p','a','t','f2ngdp'};

if ismodel(P)
   outputformat = 'model';
   m = P;
   P = struct();
   for i = 1 : length(input)
      P.(input{i}) = m.(input{i});
   end
else
   outputformat = 'dbase';
end

[P,nalt] = getmaxlength(P,input);
discrep = cell([1,nblock]);
discrep(:) = {cell([1,nalt])};
exitflag = cell([1,nblock]);
exitflag(:) = {nan([1,nalt])};
for i = 1 : nalt
   [P,discrep{1}{i},exitflag{1}(i)] = block1(P,i,optim);
   P = block2(P,i);
   [P,discrep{3}{i},exitflag{3}(i)] = block3(P,i,optim);
   P = block4(P,i);
   P = block5(P,i);
end

if strcmpi(outputformat,'model')
   P = assign(m,P);
end

end


%**************************************************************************
function varargout = block1(varargin)
try
   sigma = varargin{1}.sigma(varargin{2});
end
try
   mu = varargin{1}.mu(varargin{2});
end
try
   k2e = varargin{1}.k2e(varargin{2});
end
try
   beta = varargin{1}.beta(varargin{2});
end
try
   gamman = varargin{1}.gamman(varargin{2});
end
try
   gammam = varargin{1}.gammam(varargin{2});
end
try
   delta = varargin{1}.delta(varargin{2});
end
try
   eta = varargin{1}.eta(varargin{2});
end
try
   nu = varargin{1}.nu(varargin{2});
end
try
   pwstar = varargin{1}.pwstar(varargin{2});
end
try
   p = varargin{1}.p(varargin{2});
end
try
   a = varargin{1}.a(varargin{2});
end
try
   t = varargin{1}.t(varargin{2});
end
try
   f2ngdp = varargin{1}.f2ngdp(varargin{2});
end
X__ = zeros([1,5]);
try 
  X__(1) = log(varargin{1}.omega(1,varargin{2}));
catch
   try
     X__(1) = log(varargin{1}.omega(1,varargin{2}-1));
   end
end
try 
  X__(2) = log(varargin{1}.lambda(1,varargin{2}));
catch
   try
     X__(2) = log(varargin{1}.lambda(1,varargin{2}-1));
   end
end
try 
  X__(3) = log(varargin{1}.rk2r(1,varargin{2}));
catch
   try
     X__(3) = log(varargin{1}.rk2r(1,varargin{2}-1));
   end
end
try 
  X__(4) = log(varargin{1}.rl2r(1,varargin{2}));
catch
   try
     X__(4) = log(varargin{1}.rl2r(1,varargin{2}-1));
   end
end
try 
  X__(5) = log(varargin{1}.re2r(1,varargin{2}));
catch
   try
     X__(5) = log(varargin{1}.re2r(1,varargin{2}-1));
   end
end
varargout{1} = varargin{1};
[X__,varargout{2},varargout{3}] = fsolve(@solve__,X__,varargin{3});
varargout{1}.omega(1,varargin{2}) = exp(X__(1));
varargout{1}.lambda(1,varargin{2}) = exp(X__(2));
varargout{1}.rk2r(1,varargin{2}) = exp(X__(3));
varargout{1}.rl2r(1,varargin{2}) = exp(X__(4));
varargout{1}.re2r(1,varargin{2}) = exp(X__(5));
	function varargout = solve__(varargin)
	omega = exp(varargin{1}(1));
	lambda = exp(varargin{1}(2));
	rk2r = exp(varargin{1}(3));
	rl2r = exp(varargin{1}(4));
	re2r = exp(varargin{1}(5));
	varargout{1} = [
	(1-lambda)*dGammafn(omega,sigma)+lambda*mu*dGfn(omega,sigma)-(0)
	(1-(1-lambda)*Gammafn(omega,sigma)-lambda*mu*Gfn(omega,sigma))*rk2r-lambda-(0)
	(Gammafn(omega,sigma)-mu*Gfn(omega,sigma))*rk2r*k2e-(k2e-1)-(0)
	(k2e-1)*rl2r-(rk2r*omega*k2e)
	re2r-(rk2r*(1-Gammafn(omega,sigma))*k2e)
	];
	end
end

%**************************************************************************
function varargout = block2(varargin)
try
   sigma = varargin{1}.sigma(varargin{2});
end
try
   mu = varargin{1}.mu(varargin{2});
end
try
   k2e = varargin{1}.k2e(varargin{2});
end
try
   beta = varargin{1}.beta(varargin{2});
end
try
   gamman = varargin{1}.gamman(varargin{2});
end
try
   gammam = varargin{1}.gammam(varargin{2});
end
try
   delta = varargin{1}.delta(varargin{2});
end
try
   eta = varargin{1}.eta(varargin{2});
end
try
   nu = varargin{1}.nu(varargin{2});
end
try
   pwstar = varargin{1}.pwstar(varargin{2});
end
try
   p = varargin{1}.p(varargin{2});
end
try
   a = varargin{1}.a(varargin{2});
end
try
   t = varargin{1}.t(varargin{2});
end
try
   f2ngdp = varargin{1}.f2ngdp(varargin{2});
end
try
   omega = varargin{1}.omega(varargin{2});
end
try
   lambda = varargin{1}.lambda(varargin{2});
end
try
   rk2r = varargin{1}.rk2r(varargin{2});
end
try
   rl2r = varargin{1}.rl2r(varargin{2});
end
try
   re2r = varargin{1}.re2r(varargin{2});
end
Rwstar=1/beta;
Rstar=Rwstar;
R=Rstar;
Rk=R*rk2r;
Rl=R*rl2r;
Re=R*re2r;
Pwstar=pwstar;
P=p;
T=t;
A=a;
U=0;
B=0;
Py=P*(nu-1)/nu;
Pk=P;
Px=Py;
varargout{1} = varargin{1};
varargout{1}.Rwstar(1,varargin{2}) = Rwstar;
varargout{1}.Rstar(1,varargin{2}) = Rstar;
varargout{1}.R(1,varargin{2}) = R;
varargout{1}.Rk(1,varargin{2}) = Rk;
varargout{1}.Rl(1,varargin{2}) = Rl;
varargout{1}.Re(1,varargin{2}) = Re;
varargout{1}.Pwstar(1,varargin{2}) = Pwstar;
varargout{1}.P(1,varargin{2}) = P;
varargout{1}.T(1,varargin{2}) = T;
varargout{1}.A(1,varargin{2}) = A;
varargout{1}.U(1,varargin{2}) = U;
varargout{1}.B(1,varargin{2}) = B;
varargout{1}.Py(1,varargin{2}) = Py;
varargout{1}.Pk(1,varargin{2}) = Pk;
varargout{1}.Px(1,varargin{2}) = Px;
end

%**************************************************************************
function varargout = block3(varargin)
try
   sigma = varargin{1}.sigma(varargin{2});
end
try
   mu = varargin{1}.mu(varargin{2});
end
try
   k2e = varargin{1}.k2e(varargin{2});
end
try
   beta = varargin{1}.beta(varargin{2});
end
try
   gamman = varargin{1}.gamman(varargin{2});
end
try
   gammam = varargin{1}.gammam(varargin{2});
end
try
   delta = varargin{1}.delta(varargin{2});
end
try
   eta = varargin{1}.eta(varargin{2});
end
try
   nu = varargin{1}.nu(varargin{2});
end
try
   pwstar = varargin{1}.pwstar(varargin{2});
end
try
   p = varargin{1}.p(varargin{2});
end
try
   a = varargin{1}.a(varargin{2});
end
try
   t = varargin{1}.t(varargin{2});
end
try
   f2ngdp = varargin{1}.f2ngdp(varargin{2});
end
try
   omega = varargin{1}.omega(varargin{2});
end
try
   lambda = varargin{1}.lambda(varargin{2});
end
try
   rk2r = varargin{1}.rk2r(varargin{2});
end
try
   rl2r = varargin{1}.rl2r(varargin{2});
end
try
   re2r = varargin{1}.re2r(varargin{2});
end
try
   Rwstar = varargin{1}.Rwstar(varargin{2});
end
try
   Rstar = varargin{1}.Rstar(varargin{2});
end
try
   R = varargin{1}.R(varargin{2});
end
try
   Rk = varargin{1}.Rk(varargin{2});
end
try
   Rl = varargin{1}.Rl(varargin{2});
end
try
   Re = varargin{1}.Re(varargin{2});
end
try
   Pwstar = varargin{1}.Pwstar(varargin{2});
end
try
   P = varargin{1}.P(varargin{2});
end
try
   T = varargin{1}.T(varargin{2});
end
try
   A = varargin{1}.A(varargin{2});
end
try
   U = varargin{1}.U(varargin{2});
end
try
   B = varargin{1}.B(varargin{2});
end
try
   Py = varargin{1}.Py(varargin{2});
end
try
   Pk = varargin{1}.Pk(varargin{2});
end
try
   Px = varargin{1}.Px(varargin{2});
end
X__ = zeros([1,13]);
try 
  X__(1) = log(varargin{1}.C(1,varargin{2}));
catch
   try
     X__(1) = log(varargin{1}.C(1,varargin{2}-1));
   end
end
try 
  X__(2) = log(varargin{1}.N(1,varargin{2}));
catch
   try
     X__(2) = log(varargin{1}.N(1,varargin{2}-1));
   end
end
try 
  X__(3) = log(varargin{1}.I(1,varargin{2}));
catch
   try
     X__(3) = log(varargin{1}.I(1,varargin{2}-1));
   end
end
try 
  X__(4) = log(varargin{1}.K(1,varargin{2}));
catch
   try
     X__(4) = log(varargin{1}.K(1,varargin{2}-1));
   end
end
try 
  X__(5) = log(varargin{1}.Y(1,varargin{2}));
catch
   try
     X__(5) = log(varargin{1}.Y(1,varargin{2}-1));
   end
end
try 
  X__(6) = log(varargin{1}.X(1,varargin{2}));
catch
   try
     X__(6) = log(varargin{1}.X(1,varargin{2}-1));
   end
end
try 
  X__(7) = log(varargin{1}.M(1,varargin{2}));
catch
   try
     X__(7) = log(varargin{1}.M(1,varargin{2}-1));
   end
end
try 
  X__(8) = log(varargin{1}.Pm(1,varargin{2}));
catch
   try
     X__(8) = log(varargin{1}.Pm(1,varargin{2}-1));
   end
end
try 
  X__(9) = log(varargin{1}.Q(1,varargin{2}));
catch
   try
     X__(9) = log(varargin{1}.Q(1,varargin{2}-1));
   end
end
try 
  X__(10) = log(varargin{1}.S(1,varargin{2}));
catch
   try
     X__(10) = log(varargin{1}.S(1,varargin{2}-1));
   end
end
try 
  X__(11) = log(varargin{1}.W(1,varargin{2}));
catch
   try
     X__(11) = log(varargin{1}.W(1,varargin{2}-1));
   end
end
try 
  X__(12) = log(varargin{1}.F(1,varargin{2}));
catch
   try
     X__(12) = log(varargin{1}.F(1,varargin{2}-1));
   end
end
try 
  X__(13) = log(varargin{1}.NGDP(1,varargin{2}));
catch
   try
     X__(13) = log(varargin{1}.NGDP(1,varargin{2}-1));
   end
end
varargout{1} = varargin{1};
[X__,varargout{2},varargout{3}] = fsolve(@solve__,X__,varargin{3});
varargout{1}.C(1,varargin{2}) = exp(X__(1));
varargout{1}.N(1,varargin{2}) = exp(X__(2));
varargout{1}.I(1,varargin{2}) = exp(X__(3));
varargout{1}.K(1,varargin{2}) = exp(X__(4));
varargout{1}.Y(1,varargin{2}) = exp(X__(5));
varargout{1}.X(1,varargin{2}) = exp(X__(6));
varargout{1}.M(1,varargin{2}) = exp(X__(7));
varargout{1}.Pm(1,varargin{2}) = exp(X__(8));
varargout{1}.Q(1,varargin{2}) = exp(X__(9));
varargout{1}.S(1,varargin{2}) = exp(X__(10));
varargout{1}.W(1,varargin{2}) = exp(X__(11));
varargout{1}.F(1,varargin{2}) = exp(X__(12));
varargout{1}.NGDP(1,varargin{2}) = exp(X__(13));
	function varargout = solve__(varargin)
	C = exp(varargin{1}(1));
	N = exp(varargin{1}(2));
	I = exp(varargin{1}(3));
	K = exp(varargin{1}(4));
	Y = exp(varargin{1}(5));
	X = exp(varargin{1}(6));
	M = exp(varargin{1}(7));
	Pm = exp(varargin{1}(8));
	Q = exp(varargin{1}(9));
	S = exp(varargin{1}(10));
	W = exp(varargin{1}(11));
	F = exp(varargin{1}(12));
	NGDP = exp(varargin{1}(13));
	varargout{1} = [
	nu/(nu-1)*N^eta*P*C-(W)
	Rk-((Q+(1-delta)*Pk)/Pk)
	I-(delta*K)
	Y-(exp(A)*K^(1-gamman-gammam)*N^gamman*M^gammam)
	gamman*Py*Y-(W*N)
	gammam*Py*Y-(Pm*M)
	(1-gamman-gammam)*Py*Y-(Q*K)
	Pm-(S*Pwstar)
	Px-(exp(T)*S*Pwstar)
	Y-(C+X+I)
	F-(f2ngdp*NGDP)
	F-(F*R-Px*X+Pm*M)
	NGDP-(P*C+P*I+Px*X-Pm*M)
	];
	end
end

%**************************************************************************
function varargout = block4(varargin)
try
   sigma = varargin{1}.sigma(varargin{2});
end
try
   mu = varargin{1}.mu(varargin{2});
end
try
   k2e = varargin{1}.k2e(varargin{2});
end
try
   beta = varargin{1}.beta(varargin{2});
end
try
   gamman = varargin{1}.gamman(varargin{2});
end
try
   gammam = varargin{1}.gammam(varargin{2});
end
try
   delta = varargin{1}.delta(varargin{2});
end
try
   eta = varargin{1}.eta(varargin{2});
end
try
   nu = varargin{1}.nu(varargin{2});
end
try
   pwstar = varargin{1}.pwstar(varargin{2});
end
try
   p = varargin{1}.p(varargin{2});
end
try
   a = varargin{1}.a(varargin{2});
end
try
   t = varargin{1}.t(varargin{2});
end
try
   f2ngdp = varargin{1}.f2ngdp(varargin{2});
end
try
   omega = varargin{1}.omega(varargin{2});
end
try
   lambda = varargin{1}.lambda(varargin{2});
end
try
   rk2r = varargin{1}.rk2r(varargin{2});
end
try
   rl2r = varargin{1}.rl2r(varargin{2});
end
try
   re2r = varargin{1}.re2r(varargin{2});
end
try
   Rwstar = varargin{1}.Rwstar(varargin{2});
end
try
   Rstar = varargin{1}.Rstar(varargin{2});
end
try
   R = varargin{1}.R(varargin{2});
end
try
   Rk = varargin{1}.Rk(varargin{2});
end
try
   Rl = varargin{1}.Rl(varargin{2});
end
try
   Re = varargin{1}.Re(varargin{2});
end
try
   Pwstar = varargin{1}.Pwstar(varargin{2});
end
try
   P = varargin{1}.P(varargin{2});
end
try
   T = varargin{1}.T(varargin{2});
end
try
   A = varargin{1}.A(varargin{2});
end
try
   U = varargin{1}.U(varargin{2});
end
try
   B = varargin{1}.B(varargin{2});
end
try
   Py = varargin{1}.Py(varargin{2});
end
try
   Pk = varargin{1}.Pk(varargin{2});
end
try
   Px = varargin{1}.Px(varargin{2});
end
try
   C = varargin{1}.C(varargin{2});
end
try
   N = varargin{1}.N(varargin{2});
end
try
   I = varargin{1}.I(varargin{2});
end
try
   K = varargin{1}.K(varargin{2});
end
try
   Y = varargin{1}.Y(varargin{2});
end
try
   X = varargin{1}.X(varargin{2});
end
try
   M = varargin{1}.M(varargin{2});
end
try
   Pm = varargin{1}.Pm(varargin{2});
end
try
   Q = varargin{1}.Q(varargin{2});
end
try
   S = varargin{1}.S(varargin{2});
end
try
   W = varargin{1}.W(varargin{2});
end
try
   F = varargin{1}.F(varargin{2});
end
try
   NGDP = varargin{1}.NGDP(varargin{2});
end
Lambda=1/(P*C);
E=Pk*K/k2e;
L=Pk*K-E;
Rl=Rk*Pk*K*omega/L;
D=L-F;
Pk1=Pk;
Rk1=Rk;
GDP=exp(P*C/NGDP*log(C)+P*I/NGDP*log(I)+Px*X/NGDP*log(X)-Pm*M/NGDP*log(M));
dP=1;
dW=1;
d4P=1;
lambda0=lambda;
omega0=omega;
Rl0=Rl;
varargout{1} = varargin{1};
varargout{1}.Lambda(1,varargin{2}) = Lambda;
varargout{1}.E(1,varargin{2}) = E;
varargout{1}.L(1,varargin{2}) = L;
varargout{1}.Rl(1,varargin{2}) = Rl;
varargout{1}.D(1,varargin{2}) = D;
varargout{1}.Pk1(1,varargin{2}) = Pk1;
varargout{1}.Rk1(1,varargin{2}) = Rk1;
varargout{1}.GDP(1,varargin{2}) = GDP;
varargout{1}.dP(1,varargin{2}) = dP;
varargout{1}.dW(1,varargin{2}) = dW;
varargout{1}.d4P(1,varargin{2}) = d4P;
varargout{1}.lambda0(1,varargin{2}) = lambda0;
varargout{1}.omega0(1,varargin{2}) = omega0;
varargout{1}.Rl0(1,varargin{2}) = Rl0;
end

%**************************************************************************
function varargout = block5(varargin)
try
   sigma = varargin{1}.sigma(varargin{2});
end
try
   mu = varargin{1}.mu(varargin{2});
end
try
   k2e = varargin{1}.k2e(varargin{2});
end
try
   beta = varargin{1}.beta(varargin{2});
end
try
   gamman = varargin{1}.gamman(varargin{2});
end
try
   gammam = varargin{1}.gammam(varargin{2});
end
try
   delta = varargin{1}.delta(varargin{2});
end
try
   eta = varargin{1}.eta(varargin{2});
end
try
   nu = varargin{1}.nu(varargin{2});
end
try
   pwstar = varargin{1}.pwstar(varargin{2});
end
try
   p = varargin{1}.p(varargin{2});
end
try
   a = varargin{1}.a(varargin{2});
end
try
   t = varargin{1}.t(varargin{2});
end
try
   f2ngdp = varargin{1}.f2ngdp(varargin{2});
end
try
   omega = varargin{1}.omega(varargin{2});
end
try
   lambda = varargin{1}.lambda(varargin{2});
end
try
   rk2r = varargin{1}.rk2r(varargin{2});
end
try
   rl2r = varargin{1}.rl2r(varargin{2});
end
try
   re2r = varargin{1}.re2r(varargin{2});
end
try
   Rwstar = varargin{1}.Rwstar(varargin{2});
end
try
   Rstar = varargin{1}.Rstar(varargin{2});
end
try
   R = varargin{1}.R(varargin{2});
end
try
   Rk = varargin{1}.Rk(varargin{2});
end
try
   Rl = varargin{1}.Rl(varargin{2});
end
try
   Re = varargin{1}.Re(varargin{2});
end
try
   Pwstar = varargin{1}.Pwstar(varargin{2});
end
try
   P = varargin{1}.P(varargin{2});
end
try
   T = varargin{1}.T(varargin{2});
end
try
   A = varargin{1}.A(varargin{2});
end
try
   U = varargin{1}.U(varargin{2});
end
try
   B = varargin{1}.B(varargin{2});
end
try
   Py = varargin{1}.Py(varargin{2});
end
try
   Pk = varargin{1}.Pk(varargin{2});
end
try
   Px = varargin{1}.Px(varargin{2});
end
try
   C = varargin{1}.C(varargin{2});
end
try
   N = varargin{1}.N(varargin{2});
end
try
   I = varargin{1}.I(varargin{2});
end
try
   K = varargin{1}.K(varargin{2});
end
try
   Y = varargin{1}.Y(varargin{2});
end
try
   X = varargin{1}.X(varargin{2});
end
try
   M = varargin{1}.M(varargin{2});
end
try
   Pm = varargin{1}.Pm(varargin{2});
end
try
   Q = varargin{1}.Q(varargin{2});
end
try
   S = varargin{1}.S(varargin{2});
end
try
   W = varargin{1}.W(varargin{2});
end
try
   F = varargin{1}.F(varargin{2});
end
try
   NGDP = varargin{1}.NGDP(varargin{2});
end
try
   Lambda = varargin{1}.Lambda(varargin{2});
end
try
   E = varargin{1}.E(varargin{2});
end
try
   L = varargin{1}.L(varargin{2});
end
try
   Rl = varargin{1}.Rl(varargin{2});
end
try
   D = varargin{1}.D(varargin{2});
end
try
   Pk1 = varargin{1}.Pk1(varargin{2});
end
try
   Rk1 = varargin{1}.Rk1(varargin{2});
end
try
   GDP = varargin{1}.GDP(varargin{2});
end
try
   dP = varargin{1}.dP(varargin{2});
end
try
   dW = varargin{1}.dW(varargin{2});
end
try
   d4P = varargin{1}.d4P(varargin{2});
end
try
   lambda0 = varargin{1}.lambda0(varargin{2});
end
try
   omega0 = varargin{1}.omega0(varargin{2});
end
try
   Rl0 = varargin{1}.Rl0(varargin{2});
end
PxX2NGDP=Px*X/NGDP;
PmM2NGDP=Pm*M/NGDP;
PC2NGDP=P*C/NGDP;
WN2NGDP=W*N/NGDP;
PkK2NGDP=Pk*K/NGDP;
PI2NGDP=P*I/NGDP;
X2C=X/C;
I2C=I/C;
E2NGDP=E/NGDP;
E2PkK=E/(Pk*K);
varargout{1} = varargin{1};
varargout{1}.PxX2NGDP(1,varargin{2}) = PxX2NGDP;
varargout{1}.PmM2NGDP(1,varargin{2}) = PmM2NGDP;
varargout{1}.PC2NGDP(1,varargin{2}) = PC2NGDP;
varargout{1}.WN2NGDP(1,varargin{2}) = WN2NGDP;
varargout{1}.PkK2NGDP(1,varargin{2}) = PkK2NGDP;
varargout{1}.PI2NGDP(1,varargin{2}) = PI2NGDP;
varargout{1}.X2C(1,varargin{2}) = X2C;
varargout{1}.I2C(1,varargin{2}) = I2C;
varargout{1}.E2NGDP(1,varargin{2}) = E2NGDP;
varargout{1}.E2PkK(1,varargin{2}) = E2PkK;
end

%**************************************************************************
function [P,maxlength] = getmaxlength(P,list)
nlist = numel(list);
n = nan([1,nlist]);
for i = 1 : nlist
   try
      P.(list{i}) = transpose(P.(list{i})(:));
      n(i) = length(P.(list{i}));
   end
end
maxlength = max([1,n(~isnan(n))]);
index = 1 : nlist;
index(n == maxlength) = [];
for i = index
   try
      P.(list{i}) = ...
         [P.(list{i}),P.(list{i})(end)*ones([1,maxlength-n(i)])];
   end
end
end