function [P,discrep,exitflag] = finacc_sstate(P,varargin)
% Steady-state file based on |SOEMOLIvFA_sstate.s|.
% Automatically generated by The IRIS Toolbox, 07-Apr-2010 13:26:45.

nblock = 1;
optim = optimset(varargin{:});
input = {'sigma','mu','k2e','beta','gamman','gammam','delta','eta','nu','pwstar','p','a','t','f2ngdp'};

if ismodel(P)
   outputformat = 'model';
   m = P;
   P = struct();
   for i = 1 : length(input)
      P.(input{i}) = m.(input{i});
   end
else
   outputformat = 'dbase';
end

[P,nalt] = getmaxlength(P,input);
discrep = cell([1,nblock]);
discrep(:) = {cell([1,nalt])};
exitflag = cell([1,nblock]);
exitflag(:) = {nan([1,nalt])};
for i = 1 : nalt
   [P,discrep{1}{i},exitflag{1}(i)] = block1(P,i,optim);
end

if strcmpi(outputformat,'model')
   P = assign(m,P);
end

end


%**************************************************************************
function varargout = block1(varargin)
try
   sigma = varargin{1}.sigma(varargin{2});
end
try
   mu = varargin{1}.mu(varargin{2});
end
try
   k2e = varargin{1}.k2e(varargin{2});
end
try
   beta = varargin{1}.beta(varargin{2});
end
try
   gamman = varargin{1}.gamman(varargin{2});
end
try
   gammam = varargin{1}.gammam(varargin{2});
end
try
   delta = varargin{1}.delta(varargin{2});
end
try
   eta = varargin{1}.eta(varargin{2});
end
try
   nu = varargin{1}.nu(varargin{2});
end
try
   pwstar = varargin{1}.pwstar(varargin{2});
end
try
   p = varargin{1}.p(varargin{2});
end
try
   a = varargin{1}.a(varargin{2});
end
try
   t = varargin{1}.t(varargin{2});
end
try
   f2ngdp = varargin{1}.f2ngdp(varargin{2});
end
X__ = zeros([1,5]);
try 
  X__(1) = log(varargin{1}.omega(1,varargin{2}));
catch
   try
     X__(1) = log(varargin{1}.omega(1,varargin{2}-1));
   end
end
try 
  X__(2) = log(varargin{1}.lambda(1,varargin{2}));
catch
   try
     X__(2) = log(varargin{1}.lambda(1,varargin{2}-1));
   end
end
try 
  X__(3) = log(varargin{1}.rk2r(1,varargin{2}));
catch
   try
     X__(3) = log(varargin{1}.rk2r(1,varargin{2}-1));
   end
end
try 
  X__(4) = log(varargin{1}.rl2r(1,varargin{2}));
catch
   try
     X__(4) = log(varargin{1}.rl2r(1,varargin{2}-1));
   end
end
try 
  X__(5) = log(varargin{1}.re2r(1,varargin{2}));
catch
   try
     X__(5) = log(varargin{1}.re2r(1,varargin{2}-1));
   end
end
varargout{1} = varargin{1};
[X__,varargout{2},varargout{3}] = fsolve(@solve__,X__,varargin{3});
varargout{1}.omega(1,varargin{2}) = exp(X__(1));
varargout{1}.lambda(1,varargin{2}) = exp(X__(2));
varargout{1}.rk2r(1,varargin{2}) = exp(X__(3));
varargout{1}.rl2r(1,varargin{2}) = exp(X__(4));
varargout{1}.re2r(1,varargin{2}) = exp(X__(5));
	function varargout = solve__(varargin)
	omega = exp(varargin{1}(1));
	lambda = exp(varargin{1}(2));
	rk2r = exp(varargin{1}(3));
	rl2r = exp(varargin{1}(4));
	re2r = exp(varargin{1}(5));
	varargout{1} = [
	(1-lambda)*dGammafn(omega,sigma)+lambda*mu*dGfn(omega,sigma)-(0)
	(1-(1-lambda)*Gammafn(omega,sigma)-lambda*mu*Gfn(omega,sigma))*rk2r-lambda-(0)
	(Gammafn(omega,sigma)-mu*Gfn(omega,sigma))*rk2r*k2e-(k2e-1)-(0)
	(k2e-1)*rl2r-(rk2r*omega*k2e)
	re2r-(rk2r*(1-Gammafn(omega,sigma))*k2e)
	];
	end
end

%**************************************************************************
function [P,maxlength] = getmaxlength(P,list)
nlist = numel(list);
n = nan([1,nlist]);
for i = 1 : nlist
   try
      P.(list{i}) = transpose(P.(list{i})(:));
      n(i) = length(P.(list{i}));
   end
end
maxlength = max([1,n(~isnan(n))]);
index = 1 : nlist;
index(n == maxlength) = [];
for i = index
   try
      P.(list{i}) = ...
         [P.(list{i}),P.(list{i})(end)*ones([1,maxlength-n(i)])];
   end
end
end