function this = exogenise(this,list,dates,weight)

if nargin < 4
   weight = 1;
end

if ischar(list)
   list = charlist2cellstr(list);
end

%**************************************************************************
% Function body.

[dateindex,outofrange] = this.dateindex(dates);
if ~isempty(outofrange)
   % Report invalid dates.
   plans.tunes.error(3,dat2charlist(outofrange));
end

nlist = numel(list);
valid = true([1,nlist]);
for i = 1 : nlist
   [ans,vecindex] = findname(this,list{i},1);
   if ~isempty(vecindex)
      this.yAnchors(vecindex,dateindex) = weight;
   else
      [ans,vecindex] = findname(this,list{i},2);
      if ~isempty(vecindex)
         this.xAnchors(vecindex,dateindex) = weight;
      else
         valid(i) = false;
      end
   end
end

% Report invalid names.
if any(~valid)
   plans.tunes.error(1,list(~valid));
end

end
% End of primary function.