classdef range
   
   properties
      startdate = [];
      enddate = [];
   end
   
   properties (Dependent = true)
      nper
      vector
   end
   
   methods
      function this = range(x)
         this.startdate = x(1);
         this.enddate = x(end);
      end
      function [x,outofrange] = dateindex(this,dates)
         x = round(dates - this.startdate + 1);
         outofrangeindex = x < 1 | x > this.nper;
         outofrange = x(outofrangeindex);
         x(outofrangeindex) = NaN;
      end
   end
   
   methods
      function nper = get.nper(this)
         nper = round(this.enddate - this.startdate + 1);
      end
      function vec = get.vector(this)
         vec = this.startdate : this.enddate;
      end
   end
   
end