function [c,Pc] = cc(C,x,Px)
% CC   FAVAR common components.

%**************************************************************************
% Function body.

meanonly = nargin < 3 || isempty(Px) || nargout < 2;
ny = size(C,1);
nalt = size(C,3);
nper = size(x,2);
ndata = size(x,3);
nloop = max([nalt,ndata]);
c = nan([ny,nper,nloop]);
if meanonly
   Pc = [];
else
   Pc = nan([ny,ny,nper,nloop]);
end
for iloop = 1 : nloop
   if iloop <= nalt
      Ci = C(:,:,iloop);
      Cit = Ci';
   end
   if iloop <= ndata
      xi = x(:,:,iloop);
      if ~meanonly
         Pxi = Px(:,:,:,iloop);
      end
   end
   c(:,:,iloop) = Ci*xi;
   if ~meanonly
      for t = 1 : nper
         Pc(:,:,t,iloop) = Ci*Pxi(:,:,t)*Cit;
      end
   end
end

end
% End of primary function.