function [A,B,K] = companion(this,alt)
% < a href="VAR/companion">COMPANION</a>  First-order companion matrices.

% The IRIS Toolbox 2009/06/23.
% Copyright 2007-2009 Jaromir Benes.

[ny,p,nalt] = size(this);

if nargin < 2
   alt = 1 : nalt;  
else
   alt = alt(:)';
end

%**************************************************************************
% Function body.

if nargin < 2
   alt = Inf;
end
if any(isinf(alt))
   alt = 1 : nalt;
elseif islogical(alt)
   alt = find(alt);
end
alt = alt(:)';
nalt = numel(alt);

if p == 0
   A = zeros([ny,ny,nalt]);
else
   A = zeros([ny*p,ny*p,nalt]);
   for i = 1 : nalt
      A(:,:,i) = [this.A(:,:,alt(i));eye([ny*(p-1),ny*p])];
   end
end

if nargout > 1
   if isempty(this.B)
      B = eye(ny);
      B = B(:,:,ones([1,nalt]));
   else
      B = this.B;
   end
   B = [B;zeros([ny*(p-1),ny,nalt])];
   if nargout > 2
      K = [this.K;zeros([ny*(p-1),nalt])];
   end
end

end
% End of primary function.