function [this,data] = demean(this,data,varargin)
% Type <a href="matlab: idoc VAR.demean">idoc VAR.demean</a> or click the link to get help on this function.

% The IRIS Toolbox 2009/09/23.
% Copyright 2007-2009 Jaromir Benes.

options = passvalopt('VAR.demean',varargin{:});

%**************************************************************************
% Function body.

[ny,p,nalt] = size(this);
stable = isstationary(this);

% Detrend data.
if nargin > 1 && nargout > 1
   [outputformat,range,y,e] = datarequest(this,data,Inf,options);
   nper = numel(range);
   if size(e,3) == 1 && nalt > 1
      y = y(:,:,ones([1,nalt]));      
      e = e(:,:,ones([1,nalt]));
   end
   repeat = ones([1,nper]);
   ymean = mean(this);
   for iloop = find(stable)
      y(:,:,iloop) = ...
         y(:,:,iloop) - ymean(:,iloop*repeat);
   end
   data = outputdata(this,outputformat,range,[y;e],[],'names');
end

% Remove constant from VAR.
this.K(:,stable) = 0;

if any(~stable)
   VAR.warning(8,sprintf(' #%g',find(~stable)));
end

end
% End of primary function.