function flag = isexplosive(this,varargin)
% ISEXPLOSIVE  True if any VAR eigenvalue is outside unit circle.
%
% Syntax:
%   flag = isexplosive(this)
% Output arguments:
%   flag [ logical ] True if any VAR eigenvalue is outside unit circle.
% Required input arguments:
%   this [ VAR ] VAR model.
% <a href="options.html">Optional input arguments:</a>
%   'tolerance' [ numeric | getrealsmall() ] Numerical tolerance for eigenvalue test.

% The IRIS Toolbox.
% Copyright 2007-2009 Jaromir Benes.

default = {...
  'tolerance',getrealsmall(),@isnumericscalar, ...
};
options = passvalopt(default,varargin{:});

%**************************************************************************
% Function body.

flag = any(abs(this.eigval) > 1+options.tolerance,2);
flag = flag(:)';

end
% End of primary function.