function flag = isstationary(w,varargin)
% ISSTATIONARY  True if all VAR eigenvalues are within unit circle.
%
% Syntax:
%   flag = isstationary(w)
% Output arguments:
%   flag [ logical ] True if all VAR eigenvalues are within unit circle.
% Required input arguments:
%   w [ VAR ] VAR model.
% <a href="options.html">Optional input arguments:</a>
%   'tolerance' [ numeric | getrealsmall() ] Numerical tolerance for eigenvalue test.

% The IRIS Toolbox.
% Copyright 2007 Jaromir Benes.

default = {...
  'tolerance',getrealsmall(),@isnumericscalar, ...
};
options = passvalopt(default,varargin{:});

%**************************************************************************
% Function body.

flag = all(abs(w.eigval) <= 1-options.tolerance,2);
flag = flag(:)';

end
% End of primary function.