function ymean = mean(w,alt)
% Type <a href="matlab: idoc VAR.mean">idoc VAR.mean</a> or click the link to get help on this function.

% The IRIS Toolbox 2009/09/23.
% Copyright 2007-2009 Jaromir Benes.

%**************************************************************************
% Function body. 

[ny,p,nalt] = size(w);
if nargin < 2
   alt = 1 : nalt;
end

if p == 0
   ymean = w.K(:,alt);
   return
end

nalt = numel(alt);
realsmall = getrealsmall();
ymean = nan([ny,nalt]);
for i = 1 : nalt
   alti = alt(i);
   [T,R,k,Z,H,d,U] = sspace(w,alti);
   nunit = sum(abs(abs(w.eigval(1,:,alti)) - 1) <= realsmall);
   tmpmean = sum(time_domain.var2poly(T(nunit+1:end,nunit+1:end)),3) \ k(nunit+1:end,1);
   index = ~isdiffuse(w.eigval(1,:,alti),U(:,:));
   index(ny+1:end) = [];
   ymean(index,i) = U(index,nunit+1:end)*tmpmean;
end

end
% End of primary function.