function this = selectalt(this,index)
% SELECTALT  Called from subsobj super-class. Fetch object with index of
% alts.

% The IRIS Toolbox 2009/04/28.
% Copyright 2007-2009 Jaromir Benes.

%**************************************************************************
% Function body.

this.A = this.A(:,:,index);
this.K = this.K(:,index);
this.Omega = this.Omega(:,:,index);
this.aic = this.aic(1,index);
this.sbc = this.sbc(1,index);
this.eigval = this.eigval(1,:,index);
this.T = this.T(:,:,index);
this.U = this.U(:,:,index);
if ~isempty(this.Sigma)
   % Cov of parameters.
   this.Sigma = this.Sigma(:,:,index);
end
if ~isempty(this.B)
   % Structural VAR.
   this.B = this.B(:,:,index);
   this.std = this.std(1,index);
end

end
% End of function body.