function Omega = somega_(this,alt)
   % SOMEGA_  Covariance matrix of structural innovations.

   % The IRIS Toolbox 2009/09/14.
   % Copyright 2007-2009 Jaromir Benes.


%**************************************************************************
% Function body.

[ny,p,nalt] = size(this);

if nargin < 2 || (isnumeric(alt) && any(isinf(alt)))
   alt = 1 : nalt;
else
   alt = alt(:)';
end

Omega = nan([ny,ny,length(alt)]);
var = this.std(1,alt).^2;
for i = 1 : length(alt)
   x = var(i);
   Omega(:,:,i) = diag(x(ones([1,ny])));
end

end
% End of primary function.