function Phi = vma(w,nper)
%
% <a href="matlab: edit rvar/vma">VMA</a>  VMA representation of RVAR.
%
% Syntax:
%   Phi = vma(w,nper)
% Output arguments:
%   Phi [ numeric ] VMA matrices.
% Required input arguments:
%   w [ rvar ] RVAR model.
%   nper [ numeric ] Order up to which VMA is computed.

% The IRIS Toolbox.
% Copyright 2007-2009 Jaromir Benes.

if ~isnumeric(nper)
   error('Incorrect type of input argument(s).');
end

%**************************************************************************
% Function body.

Phi = time_domain.var2vma(w.A,w.B,nper);

end
% End of primary function.