function c = clone(inputfile,outputfile,varargin)

[options,varargin] = passvalopt('irisparser.clone',varargin{:});

% TODO: 

%**************************************************************************
% Function body.

p = irisparser(inputfile,options.assign);
block = irisparser.model_readblocks(p.code,p.fname);
[name,nametype] = irisparser.model_readnames(block);
subsname = irisparser.model_readsubs(block);
name = [name,subsname];
nametype = [nametype,5*ones(size(subsname))];

nname = length(name);
newname = cell([1,nname]);

for i = 1 : 2 : length(varargin)
   pattern = varargin{i+1}{1};
   replace = varargin{i+1}{2};
   if pattern(1) ~= '^'
      pattern = ['^',pattern];
   end
   if pattern(end) ~= '$'
      pattern = [pattern,'$'];
   end
   switch lower(varargin{i})
      case {'all'} % All names.
         index = true([1,nname]);
      case {'x'} % Transition variables.
         index = nametype == 2;
      case {'y'} % Measurement variables.
         index = nametype == 1;
      case {'p'} % Parameters.
         index = nametype == 4;
      case {'e'} % Shocks.
         index = nametype == 3;
      case {'s'} % Substitutions.
         index = nametype == 5;
      otherwise
         index = [];
   end
      newname(index) = ...
         regexprep(name(index),pattern,replace);
end

c = p.code;
for i = 1 : nname
   c = regexprep(c,['\<',name{i},'\>'],newname{i});
end

c = labelstore(p,c,'''%s''');

if ~isempty(outpufile)
   char2file(c,outputfile);
end

end
% End of primary function.