function error(code,fname,list,varargin)

fname = strrep(fname,'\','/');
intro = sprintf('Error parsing file(s) ''%s''. ',fname);

switch code
   case 0
      msg = ...
         sprintf('Cannot find !%s:transition. This is not a valid model code.', ...
         varargin{1});
   case 1
      msg = ...
         'This is not a valid keyword: ''%s''.';
   case 2
      msg = ...
         'This is not a valid variable or parameter name: ''%s''.';
   case 3
      msg = ...
         'This name is declared more than once: ''%s''.';
   case 4
      msg = ...
         'This name cannot be declared in !variables:log: ''%s''.';
   case 6
      msg = ...
         sprintf('Invalid model structure. %s',varargin{1});
   case 8
      msg = ...
         'Syntax error in ''%s'' \n\t%s';
   case 9
      msg = ...
         'Cannot evaluate this time index: ''%s''.';
   case 10
      msg = ...
         sprintf('Invalid body of a %s command: ''%%s''.',varargin{1});
   case 38
      msg = ...
         'Undeclared or mistyped name ''%s'' in equation ''%s''.';
   case 52
      msg = ...
         'Keyword !allbut may appear in either all or none of !variables:log sections.';
   case 55
      msg = ...
         'Invalid deterministic trend equation: ''%s''.';
   case 67
      msg = ...
         'Invalid dynamic link equation: ''%s''.';
   case 68
      msg = ...
         sprintf('The file contains characters beyond char(%g).',varargin{1});
   case 69
      msg = ...
         'One or more unmatched or misplaced control commands: ''%s''.';
   case 70
      msg = ...
         'The !allbut keyword used inconsistently in block #%g.';
   case 71
      msg = ...
         'This variable is declared more than once in block #%g: ''%s''.';
   case 72
      msg = ...
         'Number of equations (%g) does not match number of variables (%g) in block #%g.';
   case 73
      msg = ...
         'This is a reserved symbol in Symbolic Math Tbx and cannot be used: ''%s''.';
   case 74
      msg = 'Steady-state references ''&'' and ''\\'' not allowed in linear models: ''%s''.';
   case 75
      msg = 'Steady-state references ''&'' and ''\\'' not allowed in deterministic-trend equations: ''%s''.'; 
   case 76
      msg = 'Steady-state references ''&'' and ''\\'' not allowed in dynamic links: ''%s''.';  
end

if nargin < 3
   list = {};
elseif ~iscell(list)
   list = {list};
end
printmsg('irisparser','error',[intro,msg],list,code);

end
% End of primary function.