function c = labelstore(p,c,format)
   % LABELSTORE  Replace #(xx) with the corresponding label or tag string.
   
   % The IRIS Toolbox.
   % Copyright 2007-2010 Jaromir Benes.

if nargin < 2
   c = p.code;
end

if nargin < 3
   format = '';
end
   
%**************************************************************************
% Function body.
   
func = @replacelabel_;
c = regexprep(c,'#\((\d+)\)','${func($1)}');

   %***********************************************************************
   % Nested function replacelabel_().
   function s = replacelabel_(s)
      index = sscanf(s,'%g');
      s = p.labels{index};
      if ~isempty(format)
         s = sprintf(format,s);
      end
   end
   % End of nested function replacelabel_().

end
% End of primary function.