function [name,nametype,shocktype,label,value] = model_readnames(block)

name = [];
nametype = [];
shocktype = [];
label = {};
value = {};

for i = [4,14,12,11,3,2,1]
   [namei,labeli,valuei] = irisparser.model_findnames(block{i});
   name = [namei,name];
   label = [labeli,label];
   value = [valuei,value];
   ni = length(namei);
   switch (i)
      % Do not assign steady states to the shocks.
      case 14
         % Non-linear shocks.
         nametype = [3*ones([1,ni],'uint8'),nametype];
         shocktype = [zeros([1,ni]),shocktype];
      case 12
         % Transition shocks.
         nametype = [3*ones([1,ni],'uint8'),nametype];
         shocktype = [2*ones([1,ni]),shocktype];
      case 11
         % Measurement shocks.
         nametype = [3*ones([1,ni],'uint8'),nametype];
         shocktype = [1*ones([1,ni]),shocktype];
      case 3 
         % Untyped shocks. For bkw compatibility only. The type of each
         % shock will be found out at the end of the model parser.
         nametype = [3*ones([1,ni],'uint8'),nametype];
         shocktype = [nan([1,ni]),shocktype];
      otherwise
         % Parameters, transition, and measurement variables.
         nametype = [i*ones([1,ni],'uint8'),nametype];
   end
end

end