function warning(code,fname,list,varargin)

if ~iswarning('irisparser') || ~iswarning('model')
   return
end
fname = strrep(fname,'\','/');
intro = sprintf('Parsing file ''%s''. ',fname);

switch code
   case 1
      msg = ...
         'Cannot evaluate !if expression ''%s''. FALSE used instead.';
   case 2
      msg = ...
         'Use <<matlab:idoc(''model_lang.shocks_transition'') !shocks:transition>> or Use <<matlab:idoc(''model_lang.shocks_measurement'') !shocks:measurement>> to declare shocks.';
end

if nargin < 3
   list = {};
elseif ~iscell(list)
   list = {list};
end
printmsg('irisparser','warning',[intro,msg],list,code);

end
% End of primary function.