function this = alter(this,n)
% ALTER  Change number of alternative parameterisations.

%**************************************************************************
% Function body.

nalt = size(this.assign,3);
if n == nalt
   return
elseif n > nalt
   % Expand number of alt params.
   index = nalt+1 : n;
   repeat = nalt*ones([1,n-nalt]);
   this.assign(1,:,index) = this.assign(1,:,repeat);
   this.eigval(1,:,index) = this.eigval(1,:,repeat);
   this.icondix(1,:,index) = this.icondix(1,:,repeat);
   for i = 1 : length(this.solution)
      s1 = size(this.solution{i},1);
      s2 = size(this.solution{i},2);
      % s1 or s2 can be zero in which case we cannot use (:,:,index).
      this.solution{i}(1:s1,1:s2,index) = this.solution{i}(1:s1,1:s2,repeat);
   end
   for i = 1 : length(this.expand)
      s1 = size(this.expand{i},1);
      s2 = size(this.expand{i},2);
      % s1 or s2 can be zero in which case we cannot use (:,:,index).
      this.expand{i}(1:s1,1:s2,index) = this.expand{i}(1:s1,1:s2,repeat);
   end
else
   % Reduce number of alt params.
   index = 1 : n;
   this.assign = this.assign(1,:,index);
   this.eigval = this.eigval(1,:,index);
   this.icondix = this.icondix(1,:,index);
   for i = 1 : length(this.solution)
      s1 = size(this.solution{i},1);
      s2 = size(this.solution{i},2);
      % s1 or s2 can be zero in which case we cannot use (:,:,index).
      this.solution{i} = this.solution{i}(1:s1,1:s2,index);
   end
   for i = 1 : length(this.expand)
      s1 = size(this.expand{i},1);
      s2 = size(this.expand{i},2);
      % s1 or s2 can be zero in which case we cannot use (:,:,index).
      this.expand{i} = this.expand{i}(1:s1,1:s2,index);
   end
end

end
% End of primary function.