function [mloglik,Score,Info,se2] = diffloglik(this,data,range,plist,varargin)
% To get help for this IRIS function
% * type <a href="matlab: idoc model.diffloglik">idoc model.diffloglik</a>, or
% * open <a href="matlab: helpbrowser">Matlab Product Help</a> and go the The IRIS Toolbox at the bottom of the Contents pane,

% The IRIS Toolbox.
% Copyright 2007-2010 Jaromir Benes.

P = inputParser();
P.addRequired('model',@ismodel);
P.addRequired('data',@(x) isstruct(x) || iscell(x));
P.addRequired('range',@isnumeric);
P.addRequired('plist',@(x) ischar(x) || iscellstr(x));
P.parse(this,data,range,plist);

[options,varargin] = passvalopt('model.diffloglik',varargin{:});
loglikoptions = loglikopt_(this,range,'t',varargin{:});

if ischar(plist)
   plist = charlist2cellstr(plist);
end

%**************************************************************************
% Function body.

data = datarequest('y',this,data,range);

% Multiple parameterizations are not allowed.
if size(this.assign,3) > 1
   error_(47,'<<matlab:idoc(''model.diffloglik'') diffloglik>>');
end

% Find parameter names and create parameter index.
pindex = findnames(this.name(this.nametype == 4),plist);
tmpisnan = isnan(pindex);
if any(tmpisnan)
   error_(68,plist(tmpisnan));
end
pindex = pindex + sum(this.nametype < 4);

[mloglik,Score,Info,se2] = ...
   diffloglik_(this,data,range,pindex,options,loglikoptions);

end
% End of primary function.