function eigval = eig(this,alt)
   % EIG  Model eigenvalues.

   % The IRIS Toolbox.
   % Copyright 2007-2009 Jaromir Benes.

if nargin < 2 || isequal(alt,Inf)
   alt = 1 : size(this.assign,3);
else
   alt = alt(:)';
end

%**************************************************************************
% Function body.

eigval = this.eigval(1,:,alt);

% Solution not available for some parameterisations.
[flag,nansolution] = isnan(this,'solution');
if flag
   warning_(44,sprintf(' %g',find(nansolution)));
end

end
% End of primary function.
