function [W,list] = ifrf(m,freq,varargin);
% To get help for this IRIS function
% * type <a href="matlab: idoc model.ifrf">idoc model.ifrf</a>, or
% * open <a href="matlab: helpbrowser">Matlab Product Help</a> and go the The IRIS Toolbox at the bottom of the Contents pane,

% The IRIS Toolbox.
% Copyright 2007-2009 Jaromir Benes.

default = {...
   'select',Inf,...
};
options = passopt(default,varargin{:});

%**************************************************************************
% Function body.

freq = freq(:)';
nfreq = length(freq);
[ny,nx,nf,nb,ne,np,nalt] = size_(m);
W = {zeros([ny+nx,ne,nfreq,nalt]),freq};

if ne > 0
   [flag,index] = isnan(m,'solution');
   for ialt = find(~index)
      [T,R,K,Z,H,D,Za,Omega] = sspace_(m,ialt,false);
      % Call Freq Domain package.
      W{1}(:,:,:,ialt) = time_domain.ifrf(T,R,K,Z,H,D,Za,Omega,freq);
   end
end

% solution not available
if flag
   warning_(44,sprintf(' #%g',find(index)));
end

% print variable names
if nargout > 1 || iscellstr(options.select)
   list = cell([1,2]);
   list{1} = [vector_(m,'y'),vector_(m,'x')];
   list{2} = vector_(m,'e');
end

% select variables (for backward compatibility only)
% use SELECT function afterwards instead
if iscellstr(options.select)
   [W{1},index,list,notfound] = select(W{1},list,options.select);
   if ~isempty(notfound)
      warning_(1,notfound);
   end
end

end
% End of primary function.