function [flag,list] = isnan(m,varargin)
% To get help for this IRIS function
% * type <a href="matlab: idoc model.isnan">idoc model.isnan</a>, or
% * open <a href="matlab: helpbrowser">Matlab Product Help</a> and go the The IRIS Toolbox at the bottom of the Contents pane,

% The IRIS Toolbox 2009/10/20.
% Copyright 2007-2009 Jaromir Benes.

if ~isempty(varargin) && (ischar(varargin{1}) &&  ~strcmp(varargin{1},':'))
   request = lower(strtrim(varargin{1}));
   varargin(1) = [];
else
   request = 'all';
end

if ~isempty(varargin) && (isnumeric(varargin{1}) || islogical(varargin{1}))
   alt = varargin{1};
   if isinf(alt)
      alt = ':';
   end
else
   alt = ':';
end

%**************************************************************************
% Function body.

switch request
   case 'all'
      assign = m.assign(1,:,alt);
      index = any(isnan(assign),3);
      if nargout > 1
         list = m.name(index);
      end
   case {'p','parameters'}
      assign = m.assign(1,:,alt);
      index = any(isnan(assign),3) & m.nametype == 4;
      if nargout > 1
         list = m.name(index);
      end
   case {'sstate'}
      assign = m.assign(1,:,alt);
      index = any(isnan(assign),3) & m.nametype <= 3;
      if nargout > 1
         list = m.name(index);
      end
   case {'solution'}
      solution = m.solution{1}(:,:,alt);
      index = any(any(isnan(solution),1),2);
      index = index(:)';
      if nargout > 1
         list = index;
      end
   case {'expansion'}
      expand = m.expand{1}(:,:,alt);
      index = any(any(isnan(expand),1),2);
      index = index(:)';
      if nargout > 1
         list = index;
      end
   otherwise
      error('Incorrect input argument: %s.',varargin{1});
end
flag = any(index);

end
% End of primary function.