function [d,h] = neighbourhood(this,obj,pct,varargin)
% <a href="matlab: edit model/neighbour">NEIGHBOUR</a>  Evaluate likelihood in neighbourhood of estimated parameters.
% To get help for this IRIS function
% * type <a href="matlab: idoc model.neighbour">idoc model.neighbour</a>, or
% * open <a href="matlab: helpbrowser">Matlab Product Help</a> and browse The IRIS Toolbox documentation in the Contents pane.

options = passvalopt('model.neighbourhood',varargin{:});

%**************************************************************************
% Function body.

d = struct();
plist = obj([],'plist');
pstar = obj([],'pstar');
np = numel(plist);
for i = 1 : np
   d.(plist{i}) = zeros([0,2]);
   for j = pct(:)'
      p = pstar;
      p(i) = pstar(i)*j;
      d.(plist{i})(end+1,:) = [p(i),obj(p)];
   end
end

if options.plot
   if strcmpi(options.subplot,'auto')
      sub = ceil(sqrt(np));
      if sub*(sub-1) >= np
         sub = [sub,sub-1];
      else
         sub = [sub,sub];
      end
   else
      sub = options.subplot;
   end
   n = prod(sub);
   count = 0;
   for i = 1 : np
      count = count + 1;
      if count > n
         count = 1;
         figure();
      end
      subplot(sub(1),sub(2),count);
      plot(d.(plist{i})(:,1),d.(plist{i})(:,2));
      hold('all');
      h = plot(pstar(i),obj(),'marker','*','lineStyle','none','color','red');
      grid('on');
      title(plist{i},'interpreter','none');
      axis('tight');
   end
end

end
% End of primary function.
