function dpack = alpha2xb_(this,dpack)
% ALPHA2XB_  Convert alpha vector to xb vector.

% The IRIS Toolbox.
% Copyright 2007-2010 Jaromir Benes.

%if nargin < 3
%   doblackout = false;
%end

%**************************************************************************
% Function body.

nx = size(this.solution{1},1);
nb = size(this.solution{7},1);
nf = nx - nb;
nalt = size(this.assign,3);

if iscell(dpack)
   dpack = mean_(dpack);
else
   dpack.mean_ = mean_(dpack.mean_);
   if isfield(dpack,'mse_')
      dpack.mse_ = mse_(dpack.mse_);
   end
end

   %***********************************************************************
   % Nested function mean_().
   function d = mean_(d)
      ndata = size(d{2},3);
      for iloop = 1 : ndata
         if iloop <= nalt
            U = this.solution{7}(:,:,iloop);
            %blackout = nf + find(~this.icondix(1,:,iloop));
         end
         d{2}(nf+1:end,:,iloop) = U*d{2}(nf+1:end,:,iloop);
         % Black out the initial conditions that are not required.
         %if doblackout
         %   d{2}(blackout,1,iloop) = NaN;
         %end
      end
   end
   % End of nested function mse_().
   
   %***********************************************************************
   % Nested function mse_().
   function d = mse_(d)
      ndata = size(d{2},4);
      nper = size(d{2},3);
      for iloop = 1 : ndata
         if iloop <= nalt
            U = this.solution{7}(:,:,iloop);
            Ut = U.';
            %blackout = nf + find(~this.icondix(1,:,iloop));
         end
         for t = 1 : nper
            d{2}(nf+1:end,:,t,iloop) = U*d{2}(nf+1:end,:,t,iloop);
            d{2}(:,nf+1:end,t,iloop) = d{2}(:,nf+1:end,t,iloop)*Ut;
         end
         % Black out the initial conditions that are not required.
         %if doblackout
         %   d{2}(blackout,:,1,iloop) = NaN;
         %   d{2}(:,blackout,1,iloop) = NaN;
         %end
      end
   end
   % End of nested function mse_().

end
% End of primary function.