function [flag,index] = chklog_(m,alt)
% CHKLOG_  Check steady state of log variables for non-positive values.

% The IRIS Toolbox 2008/10/20.
% Copyright 2007-2009 Jaromir Benes.

%**************************************************************************
% Function body.

realsmall = getrealsmall();

if nargin < 2 || (isnumeric(alt) && any(isinf(alt)))
   alt = 1 : size(m.assign,3);
end

index = find(m.log);
index = index(any(m.assign(1,index,alt) <= realsmall,3));
flag = isempty(index);
if ~flag
   warning_(34,m.name(index));
end

end
% End of primary function.