function [D,X] = delta_(m,range,pindex,ialt)

npout = numel(pindex);
nper = numel(range);
ny = sum(m.nametype == 1);
X = zeros([ny,npout,nper]);
D = zeros([ny,nper]);

ttrend = range2ttrend_(range,m.torigin);
ttrendp = permute(ttrend,[1,3,2]);
% Reset out-of-likelihood parameters to zero.
% Set up constant deterministic regressors and impact matrix for
% out-of-likelihood parameters.
t = 1;
x0 = m.assign(1,:,ialt);
x0(1,pindex) = 0;
offset = sum(m.eqtntype <= 2);
nname = numel(m.name);

for ieq = find(m.eqtntype == 3)
   D(ieq-offset,:) = m.eqtnF{ieq}(x0,1,ttrend);
   occur = find(m.occur(ieq,(m.tzero-1)*nname+(1:nname)));
   for i = 1 : npout
      index = find(occur == pindex(i));
      if ~isempty(index)
         % Evaluate derivatives of dtrends equation w.r.t.
         % out-of-likelihood parameters.
         if ~isempty(m.deqtnF)
            % Use symbolic derivatives whenever available.
            X(ieq-offset,i,:) = m.deqtnF{ieq}{index}(x0,1,ttrendp);
         else
            % Numerical derivatives.
            x0(1,pindex(i)) = 1;
            X(ieq-offset,i,:) = ...
               m.eqtnF{ieq}(x0,1,ttrendp) - permute(D(ieq-offset,:),[1,3,2]);
            x0(1,pindex(i)) = 0;
         end
      end
   end
end

end
% End of primary function.