function varargout = dtrendsrequest_(request,m,range,alt)
% DTRENDSREQUEST_   Request properties of dtrends.

% The IRIS Toolbox 2009/09/25.
% Copyright 2007-2009 Jaromir Benes.

if nargin < 3
   range = [];
end

if nargin < 4 || any(isinf(alt))
   alt = 1 : size(m.assign,3);
elseif islogical(alt)
   alt = find(alt);
else
   alt = transpose(alt(:));
end
nalt = numel(alt);

%**************************************************************************
% Function body.

ny = sum(m.nametype == 1);
nper = numel(range);

switch request
   case 'sstate'
      eqtn = m.eqtnF(m.eqtntype == 3);
      const = zeros([ny,nalt]);
      ttrend = zeros([ny,nalt]);
      count = 0;
      for ialt = alt
         count = count + 1;
         x = m.assign(1,:,ialt);
         const(:,count) = vec(cellfun(@(fcn) fcn(x,1,0),eqtn));
         ttrend(:,count) = vec(cellfun(@(fcn) fcn(x,1,1),eqtn)) - const(:,count);
      end
      varargout{1} = const;
      varargout{2} = ttrend;
   case 'range'
      eqtn = m.eqtnF(m.eqtntype == 3);
      ttrend = range2ttrend_(range,m.torigin);
      W = zeros([ny,nper,nalt]);
      count = 0;
      if ~isempty(range)
         for ialt = alt
            count = count + 1;
            x = m.assign(1,:,ialt);
            for j = 1 : ny
               W(j,:,count) = eqtn{j}(x,1,ttrend);
            end
         end
      end
      varargout{1} = W;
end

end
% End of primary function.