function m = eqtn2afcn_(m)
% EQTN2AFCN_  Convert equations to anonymous functions.

% The IRIS Toolbox.
% Copyright 2007-2010 Jaromir Benes.

%**************************************************************************
% Function body.

% Anonymous functions for full measurement and transition equations.
for i = find(m.eqtntype <= 2)
   % Full model equations.
   if ~ischar(m.eqtnF{i})
      continue
   end
   if isempty(m.eqtnF{i})
      m.eqtnF{i} = @(x,t,L,G) 0;
   else
      m.eqtnF{i} = eval(['@(x,t,L,G) ',m.eqtnF{i}]);
   end
end

% Anonymous functions for full dtrend equations.
for i = find(m.eqtntype == 3)
   % Full model equations.
   if ~ischar(m.eqtnF{i})
      continue
   end
   if isempty(m.eqtnF{i})
      m.eqtnF{i} = @(x,t,ttrend) 0*ttrend;
   else
      m.eqtnF{i} = eval(['@(x,t,ttrend) ',m.eqtnF{i}]);
   end
end

% Anonymous functions for dynamic link equations.
for i = find(m.eqtntype == 4)
   if ~ischar(m.eqtnF{i})
      continue
   end
   if isempty(m.eqtnF{i})
      m.eqtnF{i} = [];
   else
      m.eqtnF{i} = eval(['@(x,t) ',m.eqtnF{i}]);
   end
end

end
% End of primary function.