function error_(code,list,varargin)

switch code
   case 7
      msg = 'NaN or Inf occured when evaluating ''%s''.';
   case 16
      msg = 'Unmatched curly braces in ''%s''';
   case 25
      msg = 'Initial condition for this variable not available from input data: ''%s''.';
   case 26
      msg = 'This variable is exogenised to NaNs: ''%s''.';
   case 32
      msg = 'SSTATE can handle stationary or difference-stationary models only.';
   case 33
      msg = 'Simulatenous use of anticipated and unanticipated anchors not implemented.';
   case 34
      msg = 'Plan range and simulation range must agree.';
   case 37
      msg = 'Multiple equal signs in this equation: ''%s''.';
   case 43
      msg = 'Cannot fix steady state for this variables because it is NaN: ''%s''.';
   case 44
      msg = 'Number of data sets and parameterisations must match.';
   case 46
      msg = 'Incorrect number of parameterisations or steady states or time series: ''%s''.';
   case 47
      msg = 'Cannot run %s on multiple paremeterisations or data sets.';
   case 48
      msg = 'Number of parameterisations must be at least 1.';
   case 51
      msg = 'Cannot run |simulate| with |''contributions''| and |''plan''|.';
   case 56
      msg = 'Last filter period and first forecast period must be two consecutive dates.';
   case 58
      msg = 'Size of weighting matrix or vector must agree with number of measurement variables.';
   case 59
      msg = 'Weighting matrix or vector must have at least one non-zero entry.';
   case 60
      msg = 'No variable named ''%s'' exists in the model object.';
   case 61
      msg = 'No equation labelled ''%s'' exists in the model object.';
   case 62
      msg = 'Number of instruments must match number of equations dropped from model.';
   case 63
      msg = 'Weighting matrix must be symmetric.';
   case 64
      msg = 'Cannot estimate out-of-likelihood parameters with option ''dtrends'' set to false.';
   case 68
      msg = 'No parameter named ''%s'' exists in the model object.';
   case 69
      msg = 'Size of prediction error weighting matrix must match number of observables.';
   case 70
      msg = 'Cannot run <<matlab:idoc(''model.bn'') bn>> for I(2) models:%s';
   case 71
      msg = 'Steady-state error in parameterisation #%g in equation ''%s''.';
   case 72
      msg = 'No variable or parameter named ''%s'' exists in the model object.';
   case 73
      msg = 'Fast <<matlab:idoc(''model.loglik'') loglik>> calls with model input argument only must be preceded by a proper call.';
   case 74
      msg = 'Structural conditions (shocks) cannot be entered simultaneously in input and tune databases.';
end

if nargin == 1
   list = {};
end
if ~iscell(list)
   list = {list};
end
printmsg('model','error',msg,list,code);

end
% End of primary function.