function [R,Jk] = expand_(R,k,Xa,Xf,Ru,J,Jk)
% EXPAND_  Expand existing solution forward up to t+k.

%**************************************************************************
% Function body.

ne = size(Ru,2);
if ne == 0
   return
end
k0 = size(R,2)/ne - 1; % expansion up to t+k0 available
if k0 >= k % expansion already available
   return
end

% pre-allocate NaNs
R(:,end+(1:ne*(k-k0))) = NaN;

% expansion matrices not available
if any(any(isnan(Xa)))
   return
end

% compute expansion
for i = k0+1 : k
   Ra = -Xa*Jk*Ru; % Jk stores J^(k-1)
   Jk = Jk*J;
   Rf = Xf*Jk*Ru;
   R(:,i*ne+(1:ne)) = [Rf;Ra];
end

end
% End of primary function.
