function [time,name] = findoccur_(this,eq,type)
% Find occurences of names in an equation.

% The IRIS Toolbox.
% Copyright 2007-2010 Jaromir Benes.

%**************************************************************************
% Function body..

% Convert occurences for requested equation from sparse 2D to full 3D.
occur = reshape(full(this.occur(eq,:)),[ ...
    1, ...
    length(this.name), ...
    size(this.occur,2)/length(this.name), ...
]);

if type(1) == 'v'
   % Find occurences of variables.
   occur = occur(1,this.nametype <= 3,:);
else
   % Report occurences of parameters.
   occur = any(occur(1,this.nametype == 4,:),3);
end
[time,name] = find(permute(occur,[3,2,1]));

end
% End of primary function.