function [Omega,stdvec] = omega_(m,altindex)
% OMEGA_  Covariance matrix of residuals.

% The IRIS Toolbox.
% Copyright 2007-2010 Jaromir Benes.

%**************************************************************************
% Function body.

ne = sum(m.nametype == 3);
if nargin < 2
   altindex = 1 : size(m.assign,3);
else
   altindex = altindex(:)';
end
nselect = length(altindex);

Omega = zeros([ne,ne,nselect]);
stdvec = stdvec_(m,altindex);
for i = 1 : nselect
   Omega(:,:,i) = diag(stdvec(1,:,i).^2);
end

if nselect == 1
   % Return sparse matrix
   % if only one parameterisation is requested.
   Omega = sparse(Omega);
end

end
% End of primary function.