function [T,R,K,Z,H,D,U,Omega,stdvec] = sspace_(m,alt,expand)
% SSPACE_  General state space with forward expansion.

% The IRIS Toolbox 2009/11/17.
% Copyright 2007-2009 Jaromir Benes.

if nargin < 3
   expand = false;
end

if nargin < 2
   nalt = size(m.assign,3);
   alt = 1 : nalt;
else
   alt = alt(:).';
   nalt = numel(alt);
end

%**************************************************************************
% Function body.

T = m.solution{1}(:,:,alt);
R = m.solution{2}(:,:,alt); % Forward expansion.
K = m.solution{3}(:,:,alt);
Z = m.solution{4}(:,:,alt);
H = m.solution{5}(:,:,alt);
D = m.solution{6}(:,:,alt);
U = m.solution{7}(:,:,alt);

ne = sum(m.nametype == 3);
if ~expand
   R = R(:,1:ne);
end
if isempty(Z)
   nb = size(T,2);
   Z = zeros([0,nb,nalt]);
end
if isempty(H)
   H = zeros([0,ne,nalt]);
end
if isempty(D)
   D = zeros([0,1,nalt]);
end

if nargout > 7
   if nargout > 8
      [Omega,stdvec] = omega_(m,alt);
   else
      Omega = omega_(m,alt);
   end
end

end
% End of primary function.