function [varvec,anyvarvec,varvecindex] = ...
   std2varvec_(this,std,range,presample)
% STD2VARVEC_  Convert stdev database to vector of variances.

% The IRIS Toolbox.
% Copyright 2007-2010 Jaromir Benes.

%**************************************************************************
% Function body.

range = range(1) : range(end);
nper = numel(range);
ne = sum(this.nametype == 3);
stdlist = this.name(end-ne+1:end);
varvec = nan([ne,nper]);

if ~isempty(std)
   for i = 1 : length(stdlist)
      if isfield(std,stdlist{i})
         if istseries(std.(stdlist{i}))
            x = rangedata(std.(stdlist{i}),range);
            x = x(:).';
         else
            x = std.(stdlist{i});
         end
         varvec(i,:) = x.^2;
      end
   end
end

% Add a number of pre-sample NaNs if requested.
if nargin > 3 && presample > 0
   varvec = [nan([size(varvec,1),presample,size(varvec,3)]),varvec];
end

if nargout > 1
   varvecindex = ~isnan(varvec);
   anyvarvec = any(varvecindex(:));
end

end
% End of primary function.