function stdvec = stdvec_(m,altindex)
% OMEGA_  Covariance matrix of residuals.

% The IRIS Toolbox.
% Copyright 2007-2010 Jaromir Benes.

if nargin < 2
   altindex = 1 : size(m.assign,3);
else
   altindex = altindex(:).';
end

%**************************************************************************
% Function body.

ne = sum(m.nametype == 3);
nselect = length(altindex);

pindex = find(m.nametype == 4);
stdvec = m.assign(1,pindex(end-ne+1:end),altindex);
% Set stdevs of non-linear shocks to zero.
stdvec(1,m.shocktype == 0,:) = 0;

end
% End of primary function.