function vec = vector_(this,varargin)
% VECTOR_  Vectors of variables in the state space.

% The IRIS Toolbox.
% Copyright 2007-2010 Jaromir Benes.

%**************************************************************************
% Function body.

if ischar(varargin{1})
   switch lower(varargin{1})
      case 'y'
         % Measurement variables.
         realkey = this.solutionid{1};
         vec = this.name(realkey);
         vec = wrapinlog_(vec,this.log(realkey));
      case 'x'
         % Transition variables.
         realkey = real(this.solutionid{2});
         imagkey = imag(this.solutionid{2});
         vec = this.name(realkey);
         for i = find(imagkey ~= 0)
            vec{i} = sprintf('%s{%g}',vec{i},imagkey(i));
         end
         vec = wrapinlog_(vec,this.log(realkey));
      case 'e'
         % Shocks.
         realkey = this.solutionid{3};
         vec = this.name(realkey);
   end
else
   realkey = real(varargin{1});
   imagkey = imag(varargin{1});
   vec = this.name(realkey);
   for i = find(imagkey ~= 0)
      vec{i} = sprintf('%s{%g}',vec{i},imagkey(i));
   end
   vec = wrapinlog_(vec,this.log(realkey));
end

end
% End of primary function.

%**************************************************************************
% Subfunction wrapinlog_().
function vec = wrapinlog_(vec,islog)
for i = find(islog)
   vec{i} = sprintf('log(%s)',vec{i});
end
end
% End of subfunction wrapinlog_().