function warning_(code,list,varargin)

if ~iswarning('model')
   return
end

switch code
   
   case 1
      msg = 'Cannot find/match this variable name: ''%s''.';
      
   case 2
      msg = 'This parameter is not available: ''%s''.';
      
   case 3
      msg = 'Steady state may not be accurate: ''%s''.';
      
   case 4
      msg = 'Log declarations disregarded in linear models.';
      
   case 7
      msg = 'Invalid assignment of parameters.';
      
   case 8
      msg = 'Time series not available: ''%s''.';
      
   case 12
      msg = 'Parameter changed since last steady state and/or solution: ''%s''.';
      
   case 13
      msg = 'Cannot get growth rates for non-linear models.';
      
   case 14
      msg = 'Numerical instability. Status not reliable: ''%s''.';
      
   case 15
      msg = 'No anchored variable(s) or no free residual(s). Plain simulation run instead.';
      
   case 18
      msg = '%sidentified anchoring system. (Data points exogenized: %g. Data points endogenized: %g.)';
      
   case 19
      msg = 'Model solution expanded forward to t+%g.';
      
   case 20
      msg = 'Model solution not available. Use SOLVE first.';
      
   case 21
      msg = 'No effect of anticipated residuals (backward-looking model).';
      
   case 22
      msg = 'Numerical inaccuracy in Schur decomposition. SEVN2 patch applied.';
      
   case 23
      msg = 'Forward expansion already available up to t+%g.';
      
   case 25
      msg = 'Cannot fix steady state for this variable: ''%s''.';
      
   case 26
      msg = 'Solution not available; no stable solution:%s.';
      
   case 27
      msg = 'Solution not available; multiple stable solutions:%s.';
      
   case 28
      msg = 'Not enough information to compute some of diffuse initial conditions or out-of-likelihood parameters.';
      
   case 29
      msg = 'Solution not available; complex derivatives:%s.';
      
   case 30
      msg = 'Cannot evaluate !if..!else..!end expression: ''%s''. FALSE used instead.';
      
   case 31
      msg = 'Cannot find parameter ''%s''.';
      
   case 32
      msg = 'Solution not available; singularity in state-space form:%s.';
      
   case 33
      msg = 'Solution not available; NaN derivatives:%s.';
      
   case 34
      msg = 'This log-linear variable has non-positive steady state: ''%s''.';
      
   case 35
      msg = 'Steady state for this variable is not available: ''%s''.';
      
   case 36
      msg = 'Cannot find this equation label: ''%s''.';
      
   case 37
      msg = 'Symbolic Math Toolbox not installed. Cannot calculate symbolic derivatives.';
      
   case 39
      msg = 'Unrecognised objective function.';
      
   case 40
      msg = 'Underdetermined conditional forecast system; forecast not computed:%s.';
      
   case 41
      msg = 'Unable to use large scale method for objective functions other than -loglik.';
      
   case 42
      msg = 'Optimal rule convergence not reached:%s.';
      
   case 43
      msg = 'Unable to plug optimal rule into original model. Using iterated policy function instead.';
      
   case 44
      msg = 'Solution not available:%s.';
      
   case 45
      msg = 'Forward expansion not available:%s.';
      
   case 46
      msg = 'Parameter disregarded because its lower bound >= upper bound: ''%s''';
      
   case 47
      msg = 'Option ''removezerostd'' ignored in models with multiple parameterisations.';
      
   case 48
      msg = 'No parameters to be optimised.';
      
   case 49
      msg = 'Parameter disregarded because its starting value is out of bounds: ''%s''.';
      
   case 51
      msg = 'No data available for any measurement variable:%s.';
      
   case 52
      msg = 'Cannot symbolically evaluate some of the derivative(s): ''%s''';
      
   case 53
      msg = 'No steady-state value returned for ''%s''.';
      
   case 54
      msg = 'Some observables are non-stationary; cannot evaluate spectrum generating function:%s.';
      
   case 55
      msg = 'Cannot compute linear steady state because solution is not available:%s.';
    
   case 56
      msg = 'Non-linear simulations crashed.';
      
   case 57
      msg = 'Structural conditions (shocks) are supposed to be entered in the input, not tune, database.';
      
end

if nargin == 1
   list = {};
end

printmsg('model','warning',msg,list,code);

end