function [Phi,list] = vma(m,nper,varargin)
% To get help for this IRIS function
% * type <a href="matlab: idoc model.vma">idoc model.vma</a>, or
% * open <a href="matlab: helpbrowser">Matlab Product Help</a> and go the The IRIS Toolbox at the bottom of the Contents pane,

% The IRIS Toolbox.
% Copyright 2007-2009 Jaromir Benes.

%**************************************************************************
% Function body.

[ny,nx,nf,nb,ne,np,nalt] = size_(m);

Phi = zeros([ny+nx,ne,nper,nalt]);
[flag,index] = isnan(m,'solution');
for ialt = find(~index)
   [T,R,K,Z,H,D,U,Omega] = sspace_(m,ialt,false);
   Phi(:,:,:,ialt) = time_domain.srf(T,R,K,Z,H,D,U,Omega,nper,1);
end

% Report solutions not available.
if flag
   warning_(44,sprintf(' #%g',find(index)));
end

if nargout > 1
   list = cell([1,2]);
   list{1} = [vector_(m,'y'),vector_(m,'x')];
   list{2} = vector_(m,'e');
end

end
% End of primary function.