function x = destdize(x,xmean,xstd)
% DESTDIZE  Multiply time series by stdevs and add mean to destandardize them.
%
% Syntax:
%   x = stdize(x,xmean,xstd)
% Output arguments:
%   x [ tseries ] Standardised time series.
% Required input arguments:
%   x [ tseries ] Input time series.
%   xmean [ numeric ] Mean.
%   xstd [ numeric ] Stdev.

% The IRIS Toolbox 2009/08/04.
% Copyright 2007-2009 Jaromir Benes.

p = inputParser();
p.addRequired('x',@istseries);
p.addRequired('xmean',@isnumeric);
p.addRequired('xstd',@isnumeric);
p.parse(x,xmean,xstd);

%********************************************************************
% Function body.

x = unop_(@destdize_,x,0,xmean,xstd);

end
% End of primary function.