function x = dot(x,varargin)
% DOT  First difference of logs.
%
% Syntax:
%   x = dot(x)
%   x = dot(x,shift)
% Output arguments:
%   x [ tseries ] First difference of log of input series.
% Required input arguments:
%   x [ tseries ] Input time series.
%   shift [ numeric ] Time shift: output series is computed as log(x{t}) - log(x{t+k}).

% The IRIS Toolbox.
% Copyright 2007-2009 Jaromir Benes.

if nargin > 1 && ~isnumeric(varargin{1})
   error('Incorrect type of input argument(s).');
end

%**************************************************************************
% Function body.

x = unop_(@dot_,x,0,varargin{:});

end
% End of primary function.