function [h1,h2,link] = errorbar(varargin)
% ERRORBARS  Line plot with error bars.

% The IRIS Toolbox.
% Copyright 2007-2010 Jaromir Benes.

if nargin == 0
   h1 = [];
   h2 = [];
   lnk = [];
   return
end

if isnumericscalar(varargin{1}) && ishandle(varargin{1})
   ax = varargin{1};
   varargin(1) = [];
else
   ax = gca();
end

if isnumeric(varargin{1})
   range = varargin{1};
   varargin(1) = [];
else
   range = Inf;
end

x = varargin{1};
varargin(1) = [];

low = varargin{1};
varargin(1) = [];
if ~isempty(varargin) && istseries(varargin{1})
   low = varargin{1};
   varargin(1) = [];
else
   high = low;
end

%**************************************************************************
% Function body.

[h1,range,data,time,plotspec] = graph_(@plot,0,ax,range,x,varargin{:});

status = get(gca(),'nextPlot');
set(gca(),'nextPlot','add');
low = getdata_(low,range);
high = getdata_(high,range);
h2 = justerrorbars_(time,data,low,high,plotspec{:});
set(gca(),'nextPlot',status);
link = cell(size(h1));

for i = 1 : numel(h1)
   set(h2(i), ...
      'color',get(h1(i),'color'));
   link{i} = linkprop([h1(i),h2(i)],'color');
end
setappdata(ax,'link',link);
excludefromlegend(h2);

end
% End of primary function.