function a = pct(x,s)
% PCT  Percentage rate of change.
%
% Syntax:
%   x = pct(x)
%   x = pct(x,shift)
% Output arguments:
%   x [ tseries ] Percentage rate of change in input series.
% Required input arguments:
%   x [ tseries ] Input series.
% Required input arguments for syntax (2):
%   shift [ numeric ] Time shift, i.e lag (negative value) or lead (positive value).

% The IRIS Toolbox.
% Copyright 2007-2010 Jaromir Benes.

if nargin < 2
   s = -1;
end

if ~isnumeric(s)
  error('Incorrect type of input argument(s).');
end

%**************************************************************************
% Function body.

a = unop_(@pct_,x,0,s,1);

end
% End of primary function.