function h = band(varargin)

if isempty(varargin)
   h = [];
   return
end

if isnumeric(varargin{1}) && ishandle(varargin{1})
   ax = varargin{1};
   varargin(1) = [];
else
   ax = gca();
end

if numel(varargin) == 1 || ischar(varargin{1})
   y = varargin{1};
   x = (1 : size(y,1))';
   varargin(1) = [];
else
   x = varargin{1}(:);
   y = varargin{2};
   varargin(1:2) = [];
end

x = [x;x(end:-1:1)];
y = [min(y,[],2);max(y(end:-1:1,:),[],2)];
h = patch(x,y, ...
   'w','parent',ax,'faceColor','none','edgeColor','none');
if ~isempty(varargin)
   set(h,varargin{:});
end

ch = get(ax,'children');
ch(ch == h) = [];
ch(end+1) = h;
set(ax,'children',ch);

excludefromlegend(h);

end