function x = cut_(x)
% CUT_  Remove leading and trailing NaNs.

% The IRIS Toolbox 2009/08/02.
% Copyright 2007-2009 Jaromir Benes.

%**************************************************************************
% Function body.

if isempty(x.data)
   return
end

if ~any(any(isnan(x.data([1,end],:))))
   return
end

nanindex = all(isnan(x.data(:,:)),2);
tmpsize = size(x.data);
if all(nanindex)
   x.start = NaN;
   x.data = zeros([0,tmpsize(2:end)]);
else
   first = find(~nanindex,1);
   last = find(~nanindex,1,'last');
   x.data = x.data(first:last,:);
   x.data = reshape(x.data,[last-first+1,tmpsize(2:end)]);
   x.start = x.start + first - 1;
end

end
% End of primary function.