function h = justerrorbars_(x,y,varargin)
% JUSTERRORBARS  Add error bars to a line graph.

% The IRIS Toolbox.
% Copyright 2007-2010 Jaromir Benes.

%**************************************************************************
% Function body.

realsmall = getrealsmall();

if size(x,1) == 1
   x = transpose(x);
end
[nper,nx] = size(x);

if size(y,1) == 1
   y = transpose(y);
end
ny = size(y,2);

low = varargin{1};
varargin(1) = [];
if size(low,1) == 1
   low = transpose(low);
end
nlow = size(low,2);

if ~isempty(varargin)
   high = varargin{1};
   varargin(1) = [];
else
   high = low;
end   
if size(high,1) == 1
   high = transpose(high);
end
nhigh = size(high,2); 

n = max([nx,ny]);

xdata = nan([3*nper,n]);
ydata = nan([3*nper,n]);
for i = 1 : n
   if i <= nx
      xi = x(:,i);
   end
   if i <= ny
      yi = y(:,i);
   end
   if i <= nlow
      lowi = low(:,i);
   end
   if i <= nhigh
      highi = high(:,i);
   end
   index = abs(lowi) <= realsmall & abs(highi) <= realsmall;
   lowi(index) = NaN;
   highi(index) = NaN;
   xdata(:,i) = vec([xi,xi,nan(size(xi))]');
   ydata(:,i) = vec([yi-lowi,yi+highi,nan(size(yi))]');
end

h = plot(xdata,ydata);
if ~isempty(varargin)
   set(h,varargin{:});
end
set(h,'marker','+','linestyle','-');

end
% End of primary function.