function x = nanvar(x,flag,dim)
   xndims = ndims(x);
   if dim > xndims
      x(:) = 0;
      return
   end
   xindex = ~isnan(x);
   n = sum(xindex,dim);
   x(~xindex) = 0;
   % Compute and expand mean in appropriate dimension.
   xmean = sum(x,dim) ./ n;
   ref = cell([1,xndims]);
   ref(:) = {':'};
   ref{dim} = ones([1,size(x,dim)]); 
   xmean = xmean(ref{:});
   xmean(~xindex) = 0;
   % Compute sum of squares.
   x = sum((x - xmean).^2,dim);   
   if flag == 0
      n = n - 1;
   end
   % Compute variance whenever number of available datapoints is
   % sufficient.
   nindex = n ~= 0;
   x(nindex) = x(nindex) ./ n(nindex);
   x(~nindex) = 0;
end