function [x,xmean,xstd] = stdize_(x,flag)
% STDIZE_  Standardize column-wise data.

% The IRIS Toolbox 2009/08/04.
% Copyright 2007-2009 Jaromir Benes.

if nargin < 2
  flag = 0;
end

%********************************************************************
% Function body..

tmpsize = size(x);
x = x(:,:);

if flag == 0
  norm = 1;
else
  norm = 0;
end

ncol = size(x,2);
xmean = nan([1,ncol]);
xstd = nan([1,ncol]);
for i = 1 : ncol
  sample = ~isnan(x(:,i));
  nper = sum(sample) - norm;
  xmean(i) = mean(x(sample,i));
  x(:,i) = x(:,i) - xmean(i);
  xstd(i) = sqrt(x(sample,i)'*x(sample,i)/nper);
  x(:,i) = x(:,i) / xstd(i);
end

x = reshape(x,tmpsize);
xmean = reshape(xmean,[1,tmpsize(2:end)]);
xstd = reshape(xstd,[1,tmpsize(2:end)]);

end
% End of primary function.