function [x,varargout] = unop_(func,x,dim,varargin)
   % UNOP_  Implementation of unary operators and functions on tseries
   % objects.

   % The IRIS Toolbox.
   % Copyright 2007-2009 Jaromir Benes.

%**************************************************************************
% Function body.

if dim == 0
  % Returns tseries of the same size.
  tmpsize = size(x.data);
  [x.data,varargout{1:nargout-1}] = func(x.data(:,:),varargin{:});
  if length(tmpsize) > 2
     x.data = reshape(x.data,[size(x.data,1),tmpsize(2:end)]);
  end
  if ~isempty(x.data) && any(any(isnan(x.data([1,end],:))))
     x = cut_(x);
  end
elseif dim == 1
  % Returns numeric array as a result of applying FUNC in 1st dimension
  % (time).
  [x,varargout{1:nargout-1}] = func(x.data,varargin{:});
else
  % Returns a tseries shrunk in DIM as a result of applying FUNC in that
  % dimension
  [x.data,varargout{1:nargout-1}] = func(x.data,varargin{:});
  dim = size(x.data);
  x.comment = cell([1,dim(2:end)]);
  x.comment(:) = {''};
  if ~isempty(x.data) && any(any(isnan(x.data([1,end],:))))
     x = cut_(x);
  end
end

end
% End of primary function.