function x = replace(x,data,start,comment)

x.data = data;
if nargin > 2
   x.start = start;
end
if nargin > 3 && (iscell(comment) || ischar(comment))
   if iscell(comment)
      x.comment = comment;
   elseif ischar(comment)
      tmpsize = size(x.data);
      x.comment = cell([1,tmpsize(2:end)]);
      x.comment(:) = {comment};
   end
else
   si = size(x.data);
   x.comment = cell([1,si(2:end)]);
   x.comment(:) = {''};
end

% Cut off leading or trailing NaNs.
nanindex = all(isnan(x.data(:,:)),2);
if any(nanindex)
   tmpsize = size(x.data);
   if all(nanindex)
      x.start = NaN;
      x.data = zeros([0,tmpsize(2:end)]);
   else
      first = find(~nanindex,1);
      last = find(~nanindex,1,'last');
      x.data = x.data(first:last,:);
      x.data = reshape(x.data,[last-first+1,tmpsize(2:end)]);
      x.start = x.start + first - 1;
   end
end

end