function h = spy(varargin)

% The IRIS Toolbox.
% Copyright (c) 2007-2010 Jaromir Benes.

if isnumeric(varargin{1})
   range = varargin{1};
   varargin(1) = [];
else
   range = Inf;
end

%**************************************************************************
% Function body.

X = varargin{1};
varargin(1) = [];

options = passvalopt('tseries.spy',varargin{:});
options = datedefaults_(options,true);
freq = get(X,'freq');
[x,range] = rangedata(X,range);
x = ~isnan(x.');
spy(x);
ax = gca();
li = get(ax,'children');
xdata = get(li,'xData');
time = dat2grid(range);
xdata = time(xdata);
set(li,'xData',xdata);
timeline(ax,[range(1)-1,range(end)+1],freq,options);
set(ax,'gridLineStyle',':');
yLim = [1,size(x,1)];
if ~isempty(options.names)
   set(ax,'yTick',yLim(1):yLim(end),'yTickMode','manual', ...
      'yTickLabel',options.names,'yTickLabelMode','manual', ...
      'yLim',[0.5,yLim(end)+0.5],'yLimMode','manual');
end
xlabel('');
setappdata(ax,'tseries',true);
setappdata(ax,'freq',freq);

end
% End of primary function.