function [x,xmean,xstd] = stdize(x,varargin)
% STDIZE  Standardize time series by subtracting mean and dividing by stdev.
%
% Syntax:
%   x = stdize(x)
%   x = stdize(x,flag)
% Output arguments:
%   x [ tseries ] Standardised time series.
% Required input arguments:
%   x [ tseries ] Input time series.
%   flag [ numeric ] Flag=0 (default) normalises by N-1, flag=1 normalises by N, where N is sample length.

% The IRIS Toolbox 2009/08/04.
% Copyright 2007-2009 Jaromir Benes.

%********************************************************************
% Function body..

[x,xmean,xstd] = unop_(@stdize_,x,0,varargin{:});

end
% End of primary function.