function varargout = stem(varargin)
% STEM Stem plot function for times series.
%
% Syntax:
%   [h,rng,data,grid] = stem(x,...)
%   [h,rng,data,grid] = stem(rng,x,...)
%   [h,rng,data,grid] = stem(ax,rng,x,...)
% Required input arguments:
%   h numeric; rng numeric; x tseries; ax numeric
% <a href="options.html">Optional input arguments:</a>
%   'dateformat' char (irisget('plotdateformat'))
%   'datetick' numeric|Inf (Inf)
%   'function' function_handle (empty)
%   See also PLOT options.

% The IRIS Toolbox 2009/07/03.
% Copyright 2007-2009 Jaromir Benes.

%********************************************************************
% Function body..

[varargout{1:nargout}] = graph_(@stem,0,varargin{:});

end
% End of primary function.