function x = trend(x,range,varargin)

if nargin < 2
   range = Inf;
end

options = passvalopt('tseries.trend',varargin{:});

%**************************************************************************
% Function body.

[xdata,range] = rangedata(x,range);
nper = length(range);
tmpsize = size(xdata);
xdata = xdata(:,:);
if options.log
   xdata = log(xdata);
end
bp = round(options.break - range(1) + 1);
bp = bp(:).';
bp(bp < 1 | bp > nper) = [];
bp = sort(bp);

xdata = trend2_(xdata,options.method,bp);

if options.log
   xdata = exp(xdata);
end
xdata = reshape(xdata,[size(xdata,1),tmpsize(2:end)]);
x = replace(x,xdata,range(1));

end
% End of primary function.