function varargout = x12(x,range,varargin)
% To get help for this IRIS function
% * type <a href="matlab: idoc filter.x12">idoc filter.x12</a>, or
% * open <a href="matlab: helpbrowser">Matlab Product Help</a> and go the The IRIS Toolbox at the bottom of the Contents pane,

% The IRIS Toolbox 2009/04/19.
% Copyright 2007-2009 Jaromir Benes.

options = passvalopt('tseries.x12',varargin{:});

if strcmp(options.mode,'sign')
   options.mode = 'auto';
end

if nargin > 1 && ~isnumeric(range)
   error('Incorrect type of input argument(s).');
end

if nargin < 2
   range = Inf;
else
   range = setrange(range);
end

map = {...
   'seasonal','d10',...
   'seasadj','d11',...
   'trendcycle','d12',...
   'trend','d12',...
   'irregular','d13',...
};
for i = 1 : 2 : length(map)
   options.output = strrep(options.output,map{i},map{i+1});
end

%**************************************************************************
% Function body..

[x.data,dim] = reshape_(x.data);
[data,range] = getdata_(x,range);
tmpsize = size(data);
data = data(:,:);

if options.log
   data = log(data);
end

output = regexp(options.output,'[a-zA-Z]\d\d','match');
noutput = length(output);

[varargout{1:noutput},varargout{noutput+(1:2)}] = x12.x12(data,range(1),options);

for i = 1 : noutput
   if options.log
      varargout{i} = exp(varargout{i});
   end
   varargout{i} = reshape(varargout{i},[size(varargout{i},1),tmpsize(2:end)]);
   varargout{i} = replace(x,varargout{i},range(1));
end

end
% End of primary function.