classdef metamodel
   
   properties
      tzero = [];
      occur = [];
      name = {};
      nametype = [];
      shocktype = [];
      namelabel = {};
      eqtn = {};
      eqtnF = {};
      eqtntype = [];
      eqtnlabel = {};
      log = [];
      solutionid = {};
   end
   
   methods
      function this = metamodel(m)
         n = model2metamodel(m);
         list = properties('metamodel');
         for i = 1 : numel(list)
            this.(list{i}) = n.(list{i});
         end
      end
      
      function [nameindex,vecindex] = findname(this,name,type)
         tmpname = this.name;
         tmpname(this.nametype ~= type) = {''};
         index = strcmp(name,tmpname);
         if any(index)
            nameindex = find(index);
            vecindex = find(this.solutionid{type} == nameindex);
         else
            nameindex = [];
            vecindex = [];
         end
      end
      
      function index = findeqtnlabel(this,label,type)
         tmplabel = this.eqtnlabel;
         tmplabel(this.eqtntype ~= type) = {''};
         index = find(strcmp(label,tmplabel));
      end      
      
   end
   
   % Dependent methods.
   methods
      function ny = nyvec(this)
         ny = length(this.solutionid{1});
      end
      function nx = nxvec(this)
         nx = length(this.solutionid{2});
      end
      function ne = nevec(this)
         ne = length(this.solutionid{3});
      end
   end

end