classdef subsobj
% SUBSREFOBJ  Implement general subscripted reference and assignment for
% other classes.

   methods (Access = 'public')
      
      function this = subsobj(varargin)
      end
      
      function varargout = subsref(this,s)
         if length(s) == 1 ...
               && any(strcmp(s.type,{'()','{}'})) ...
               && length(s.subs) == 1
            nalt = length(this);
            if ischar(s.subs) && strcmp(s.subs{1},':');
               index = 1 : nalt;
            else
               index = s.subs{1};
            end
            varargout{1} = selectalt(this,index);
         else
            [varargout{1:nargout}] = specsubsref(this,s);
         end
      end
      
   end
   
   methods (Abstract = true, Access = 'protected')
      varargout = selectalt(varargin)
      varargout = specsubsref(varargin)
   end
   
end