classdef userdataobj
   % USERDATAOBJ  Implement user data storage for other classes.
   
   properties (Access = 'protected')
      storage = [];
   end
   
   methods (Access = 'public')
      
      % Contructor.
      function this = userdataobj(varargin)
         if isempty(varargin)
            return
         end
         if isa(varargin{1},'userdataobj')
            this = varargin{1};
         else
            this.storage = varargin{1};
         end
      end
      
      % Getting and setting user data.
      function varargout = userdata(this,varargin)
         if isempty(varargin)
            varargout{1} = this.storage;
         else
            this.storage = varargin{1};
            varargout{1} = this;
         end
      end
      
      function disp(this)
         if ~isempty(this.userdata)
            tmpsize = sprintf('%gx',size(this.userdata));
            tmpsize(end) = '';
            msg = sprintf('[%s %s]',tmpsize,class(this.userdata));
         else
            msg = 'empty';
         end
         fprintf('\tuser data: %s\n',msg);
      end
      
   end
   
end