function inputformat = dataformat(x,throwError)
% DATAFORMAT  Determine format of input and output data.

if nargin < 2
   throwError = true;
end

if iscell(x)
   inputformat = 'dpack';
elseif isstruct(x)
   if isfield(x,'mean_') && isfield(x,'mse_')
      inputformat = 'struct';
   else
      inputformat = 'dbase';
   end
elseif isempty(x)
   inputformat = 'empty';
else
   inputformat = 'unknown';
   if throwError
      error('iris:data','Invalid format of input data.');
   end
end

end
% End of primary function.