function varargout = dbeval(d,varargin)

% The IRIS Toolbox.
% Copyright 2007-2009 Jaromir Benes.

if (~isstruct(d) && ~ismodel(d)) || (~iscellstr(varargin) && ~iscellstr(varargin{1}))
   error('Incorrect type of input argument(s).');
end

if iscellstr(varargin)
   expr = varargin;
   multiple = true;
elseif iscellstr(varargin{1})
   expr = varargin{1};
   multiple = false;
end

%**************************************************************************
% Function body.

list = fieldnames(d).';
for i = 1 : length(list)
  expr = regexprep(expr,['(?<![\.@])(\<',list{i},'\>)'],'?.$1');
end

expr = strrep(expr,'?.','d.');
expr = strrep(expr,'@','');
expr = strrep(expr,';','');

% Convert x=y and x+=y into x-(y)
% so that we can evaluate LHS minus RHS.
expr = strrep(expr,'+=','=');
index = strfind(expr,'=');
for i = 1 : length(index)
   if length(index{i}) == 1
      expr{i} = [expr{i}(1:index{i}-1),'-(',expr{i}(index{i}+1:end),')'];
   end
end

varargout = cell(size(expr));
for i = 1 : length(expr)
   try
      varargout{i} = eval(expr{i});
   catch
      varargout{i} = NaN;
   end
end
if ~multiple
   varargout{1} = varargout;
end

end
% End of primary function.