function d = dbextend(d,varargin)
% <a href="matlab: edit dbextend">DBEXTEND</a>  Extend/overwrite time series in one database with observations available from another database(s).
%
% Syntax:
%    d = dbextend(d1,d2,...)
% Output arguments:
%    d [ struct ] Primary database.
% Required input arguments:
%    dn [ struct ] Database(s) whose time series observations will be used to extend the primary database.

% The IRIS Toolbox.
% Copyright 2007-2010 Jaromir Benes.

%********************************************************************
% Function body.

list = fieldnames(d);
for i = 1 : numel(varargin)   
   s = varargin{i};
   for j = 1 : numel(list)
      if ~isfield(s,list{j})
         continue
      end
      if istseries(d.(list{j})) ...
            && istseries(s.(list{j})) ...
            && get(d.(list{j}),'freq') == get(s.(list{j}),'freq')
         d.(list{j}) = [d.(list{j});s.(list{j})];
      else
         d.(list{j}) = s.(list{j});
      end
   end
   templist = fieldnames(s);
   templist = templist - list;
   for j = 1 : length(templist)
      d.(templist{j}) = s.(templist{j});
   end
end      

end
% End of primary function.