function varargout = dbfetch(this,varargin)
   % DBFETCH  Fetch subsets of data alternatives.

   % The IRIS Toolbox.
   % Copyright 2007-2010 Jaromir Benes.
   
varargout = cell(size(varargin));   

% Handle multiple input/output arguments.
if length(varargin) > 1
   for i = 1 : length(varargin)
      varargout{i} = dbfetch(this,varargin{i});
   end
   return
end

% Single input/output argument from here on.
index = varargin{1};
list = fieldnames(this);
if isempty(list)
   return
end
if ischar(index) && strcmp(index,'end')
   index = length(this.(list{1}));
end

%**************************************************************************
% Function body.

for i = 1 : length(list)
   if istseries(this.(list{i}))
      try
         this.(list{i}) = this.(list{i}){:,index};
      end
   elseif isnumeric(this.(list{i})) ...
         || islogical(this.(list{i})) ...
         || iscell(this.(list{i}))
      try
         this.(list{i}) = this.(list{i})(:,index);
      end
   end
end
varargout{1} = this;

end
% End of primary function.