function d = dboverlay(varargin)
% <a href="matlab: edit dboverlay">DBOVERLAY</a>  Splice databases overlaying field by field.
%
% Syntax:
%   d = dboverlay(d1,d2,...)
% Output arguments:
%   d [ struct ] Output database.
% Required input arguments:
%   d1,d2,... [ struct ] Input databases. Fields of d2 superimpose fields of d1, etc.

% The IRIS Toolbox.
% Copyright 2007 Jaromir Benes.

%**************************************************************************
% Function body.

if nargin == 0
  d = struct();
else
  d = varargin{1};
end

for k = 2 : nargin
  list = fieldnames(varargin{k});
  for m = 1 : length(list)
    try
      if istseries(d.(list{m})) && istseries(varargin{k}.(list{m}))
        d.(list{m}) = [d.(list{m});varargin{k}.(list{m})];
      else
        d.(list{m}) = varargin{k}.(list{m});
      end
    catch
      d.(list{m}) = varargin{k}.(list{m});
    end
  end
end

end
% End of primary function.