function [y,range,list,inputformat,varargin] = inputdata(varargin)
% INPUTDATA  Get data and determine range (if not user-supplied), both
% including i/c, from different types of input arguments.

% The IRIS Toolbox 2008/10/29.
% Copyright 2007-2009 Jaromir Benes.

if isstruct(varargin{1})
   inputformat = 'dbase';
   d = varargin{1};
   list = varargin{2};
   varargin(1:2) = [];
   if ischar(list)
      list = charlist2cellstr(list);
   end
   if isempty(varargin) || ~isnumeric(varargin{1})
      range = Inf;
   else
      range = varargin{1};
      varargin(1) = [];
   end
   [y,ans,range] = db2array(d,list,range);
   y = permute(y,[2,1,3]);
elseif istseries(varargin{1})
   inputformat = 'tseries';
   y = varargin{1};
   varargin(1) = [];
   if isempty(varargin) || ~isnumeric(varargin{1})
      range = Inf;
   else
      range = varargin{1};
      varargin(1) = [];
   end 
   [y,range] = rangedata(y,range);
   y = permute(y,[2,1,3]);
   list = {};
elseif isnumeric(varargin{1})
   inputformat = 'array';
   y = permute(varargin{1},[2,1,3]);
   varargin(1) = [];
   range = 1 : size(y,2);
   list = {};
else
   error('iris:var','Incorrect input data.');
end

end
% End of primary function.