function dat = bb(varargin)
% BB  Serial number(s) for date(s) with bimonthly frequency.
%
% Syntax:
%   dat = bb(year)
%   dat = bm(year,bimonth)
% Output arguments:
%   dat [ numeric ] IRIS serial date number(s).
% Required input arguments:
%   year [ numeric ] Year(s).
%   bimonth [ numeric ] Bimonth(s).

% The IRIS Toolbox.
% Copyright 2007-2009 Jaromir Benes.

%**************************************************************************
% Function body.

year = varargin{1};
if nargin == 1
  per = ones(size(year));
else
  per = varargin{2};
end
dat = datcode(year,per,6);

end
% End of primary function.