function d2 = convert(d1,f2,varargin)
% CONVERT   Convert dates from one frequency to another.

% The IRIS Toolbox.
% Copyright 2007-2010 Jaromir Benes.

if ~isnumeric(d1) || ~isnumeric(f2)
   error('iris:dates', ...
      'IRIS dates/convert.m: Invalid type of input argument(s).');
end

options = passvalopt('dates.convert',varargin{:});

config = irisget();
if isequal(options.standinmonth,'config')
   options.standinmonth = config.standinmonth;
end

%**************************************************************************
% Function body.

% Get year, period, and frequency of the original dates.
[y1,p1,f1] = dat2ypf(d1);

% First, convert the original period to a corresponding month.
m = per2month_(p1,f1,options.standinmonth);

% Then, convert the month to the corresponding period of the request
% frequnecy.
p2 = ceil(m.*f2./12);

% Create the serial date number.
d2 = datcode(y1,p2,f2);

end
% End of primary function.