function c = dat1charlist(x)
   % DAT1CHARLIST  Fast date to string conversion with no customisation.
   
   % The IRIS Toolbox.
   % Copyright 2007-2010 Jaromir Benes.
   
%**************************************************************************
% Function body.

if isempty(x)
   c = '';
   return
end

[year,per,freq] = dat2ypf(x);

if any(freq ~= freq(1))
   error('DAT1CHARLIST can only process an array of dates with the same frequencies.');
end

switch freq(1)
   case 0
      c = sprintf('%g,',per);
   case 1
      c = sprintf('%gY,',per);
   otherwise
      switch freq(1)
         case 2
            letter = 'Z';
         case 4
            letter = 'Q';
         case 6
            letter = 'B';
         case 12
            letter = 'M';
         otherwise
            letter = '?';
      end
      c = sprintf(['%g',letter,'%g,'],[year;per]);
end
c = c(1:end-1);
      
end
% End of primary function.