function dat = mm(varargin)
% MM  Serial number(s) for date(s) with monthly frequency.
%
% Syntax:
%   dat = mm(year)
%   dat = mm(year,month)
% Output arguments:
%   dat [ numeric ] IRIS serial date number(s).
% Required input arguments:
%   year [ numeric ] Year(s).
%   month [ numeric ] Month(s).

% The IRIS Toolbox.
% Copyright 2007-2009 Jaromir Benes.

%**************************************************************************
% Function body.

year = varargin{1};
if nargin == 1
  per = ones(size(year));
else
  per = varargin{2};
end
dat = datcode(year,per,12);

end
% End of primary function.