function dat = yy(varargin)
% YY  Serial number(s) for date(s) with annual frequency.
%
% Syntax:
%   dat = yy(year)
% Output arguments:
%   dat [ numeric ] IRIS serial date number(s).
% Required input arguments:
%   year [ numeric ] Year(s).

% The IRIS Toolbox.
% Copyright 2007-2010 Jaromir Benes.

%**************************************************************************
% Function body.

year = varargin{1};
% Disregard periods for annual dates.
per = ones(size(year));
dat = datcode(year,per,1);

end
% End of primary function.