function varargout = findtexmf(varargin)
% FINDTEXMF  Run KPSEWHICH to locate TeX executables.

% The IRIS Toolbox
% Copyright 2007-2009 Jaromir Benes.

%**************************************************************************
% Function body.

varargout = cell(size(varargin));
varargout(:) = {''};
for i = 1 : length(varargin)
   % Try to run KPSEWHICH.
   [flag,output] = system(sprintf('kpsewhich --file-type=exe %s',varargin{i}));
   if flag == 0
      % Use the correctly spelled path and the right file separators.
      [fpath,fname,fext] = fileparts(strtrim(output));
      varargout{i} = fullfile(fpath,[fname,fext]);
   end
end

end
% End of primary function.