function iriscleanup(varargin)
% IRISREMOVE  Remove all IRIS folders from the Matlab search path.

% The IRIS Toolbox.
% Copyright 2007-2010 Jaromir Benes.

%**************************************************************************
% Function body.

% Clear container.
clear(container());

% Clear optional input argument struct.
munlock('passvalopt');
clear('passvalopt');

% Clear iris config master file.
munlock('irisconfigmaster');
clear('irisconfigmaster');

removed = irispathmanager('cleanup');
if ~isempty(removed)
   fprintf('\n\tThe following IRIS roots have been permanently removed from Matlab path:\n');
   for i = 1 : numel(removed)
      fprintf('\t* <a href="file://Local/%s">%s</a>\n', ...
         removed{i},removed{i});
   end
   fprintf('\n');
end



end
% End of primary function.