function irisfinish(varargin)
   % IRISFINISH  End the current IRIS session and remove IRIS subfolders from
   % Matlab path.

   % The IRIS Toolbox.
   % Copyright 2007-2009 Jaromir Benes.

%**************************************************************************
% Function body.

% Clear container.
clear(container());

% Clear optional input argument struct.
munlock('passvalopt');
clear('passvalopt');

% Clear iris config master file.
munlock('irisconfigmaster');
clear('irisconfigmaster');

% Clear Matlab path.
removed = irispathmanager('removeCurrentSubs');
if ~isempty(removed)
   fprintf('\n\tThe current IRIS subfolders have been removed from Matlab path:');
   fprintf('\n\t%s\n\n',removed);
end

end
% End of primary function.