function text = grabtext(startTag,endTag)
% GRABTEXT  Retrieve commented text between STARTTAG and ENDTAG from the
% calling m-file.

% The IRIS Toolbox 2009/07/26.
% Copyright 2007-2009 Jaromir Benes.

%**************************************************************************
% Function body.

text = '';

% Determine the name of the calling m-file.
stack = dbstack('-completenames');
if length(stack) < 2
   return
end

% Read the m-file and find the text between %{\nSTARTTAG and ENDTAG\n%}.
file = file2char(stack(2).file);
file = strfun.converteols(file);
tokens = regexp(file,['%\{\n+',startTag,'\n(.*?)\n',endTag,'\n+%\}'],'once','tokens');
if ~isempty(tokens)
   text = tokens{1};
end

end
% End of primary function.