function h = conlegend(varargin)

if ~isempty(varargin) && length(varargin{1}) == 1 && ishandle(varargin{1})
   ax = varargin{1};
   varargin(1) = [];
else
   ax = gca();
end

%**************************************************************************
% Function body.

isconbar = getappdata(ax,'conbar');
if isempty(isconbar) || ~isconbar
   error('iris:graphics', ...
      'The current graph has not been created by CONBAR. Cannot use CONLEGEND.');
end

index = getappdata(ax,'index');
nindex = length(index);
if isempty(varargin)
   return
elseif iscell(varargin{1})
   entry = varargin{1};
   varargin(1) = [];
elseif length(varargin) >= nindex
   entry = varargin(1:nindex);
   varargin(1:nindex) = [];
else
   entry = varargin(:);
   varargin(:) = [];
end

nentry = length(entry);
if nentry < nindex
   entry(end+1:nindex) = {''};
end

entry = entry(index);
h = legend(ax,entry{:},varargin{:});

end
% End of primary function.