function h = predplot(varargin)

if isempty(varargin)
   return
end

if isnumeric(varargin{1}) ...
      && length(varargin{1}) == 1 ...
      && ishandle(varargin{1})
   ax = varargin{1};
else
   ax = gca();
end

if isnumeric(varargin{1})
   range = varargin{1};
   varargin(1) = [];
else
   range = Inf;
end

x1 = varargin{1};
x2 = varargin{2};
varargin(1:2) = [];

[data,range] = rangedata([x1,x2],range);
nper = size(data,1);
ahead = size(data,2);
data = [data;nan([ahead-1,ahead])];

data2 = nan([nper+ahead-1,nper]);
for t = 1 : nper
   data2(t+(0:ahead-1),t,:) = diag(data(t+(0:ahead-1),:));
end

x2 = replace(x2,data2(1:nper,:),range(1));
h1 = plot(ax,range,x1);
hold('all');
h2 = plot(ax,range,x2);
h = [h1;h2];
if ~isempty(varargin)
   set(h,varargin{:});
end

end