function [h,range,data] = qpdefault(hax,range,x,type,legendfcn,varargin)
% QPDEFAULT  QPLOT default plot function.

% The IRIS Toolbox.
% Copyright 2007-2010 Jaromir Benes.

[options,varargin] = passvalopt('quickreport.qpdefault',varargin{:});

%**************************************************************************
% Function body.

switch type
case 'line'
   data = [x{:}];
   if istseries(data)
      [h,range,data] = plot(range,data,varargin{:});
   else
      h = plot(range,data,varargin{:});
   end
case 'bar'
   data = [x{:}];
   if istseries(data)
      [h,range,data] = bar(range,[x{:}],varargin{:});
   else
      h = plot(range,data,varargin{:});
   end
end

if options.tight
   axis('tight');
end

if options.grid
   grid('on');
end

set(hax,'buttonDownFcn',@copygraph_);

tmplegend = legendfcn();
% Display legend if there is at least one non-empty entry.
if any(~cellfun(@isempty,tmplegend))
   legend(tmplegend{:},'Location','Best');
end

if options.zeroline
   zeroline(hax);
end

if ~isempty(options.highlight)
   highlight(hax,options.highlight);
end

end
% End of primary function.


%**************************************************************************
% Subfunction copygraph_().
function copygraph_(h,varargin)
copyobj(h,figure());
end
% End of subfunction copygraph_().
