function savestruct(fname,x)
% <a href="matlab: edit utils/io/savestruct">SAVESTRUCT</a>  Save struct-convertible object as struct.
%
% Syntax:
%   savestruct(fname,x)
%   savestruct(x,fname)
% Required input arguments:
%   fname [ char ] File name.
%   x [ model | tseries | VAR ] Object to save.

% The IRIS Toolbox 2009/10/15.
% Copyright 2007-2009 Jaromir Benes.

%**************************************************************************
% Function body.

% Allow both savestruct(fname,d) and savestruct(d,fname).
if (isobject(fname) || isstruct(fname) || iscell(fname)) && ischar(x)
   [fname,x] = deal(x,fname);
end

c = class(x);

switch c
   case {'model','VAR','container'}
      status = warning();
      warning('off');
      x = saveobj(x);
      x = struct(x);
      warning(status);
   case {'tseries'}
      x = struct(x);
   case 'struct'
      % Do nothing.
   otherwise
      error('Objects of class %s cannot be saved using SAVESTRUCT.',class(x));
end

x.SAVESTRUCT_CLASS = c;

% Save individual fields of underlying struct.
save(fname,'-struct','x','-mat');

end
% End of primary function.
