function pos = matchbrk(c)
% MATCHBRK  Match an opening bracket found at the beginning of char string.

% The IRIS Toolbox 2009/07/21.
% Copyright 2007-2009 Jaromir Benes.

%********************************************************************
% Function body..

c = transpose(c(:));
nc = numel(c);
open = c(1);
switch open
   case '('
      close = ')';
   case '['
      close = ']';
   case '{'
      close = '}';
   case '<'
      close = '>';
   otherwise
      error('iris:utils',...
         'String must start with one of the brackets: (, [, {, or <.');
end

x = zeros([1,nc]);
x(c == open) = 1;
x(c == close) = -1;
x = cumsum(x);
pos = find(x == 0,1,'first');
 
end
% End of primary function.