function fg = nextplot(x,varargin)

% The IRIS Toolbox.
% Copyright (c) 2007-2010 Jaromir Benes.

%**************************************************************************
% Function body.

% Open a new figure and initialise subplot data.
if nargin > 0
   if length(x) == 3
      sub = x(1:2);
      current = x(3);
   elseif length(x) == 2
      sub = x;
      current = 0;
   elseif length(x) == 1
      s = ceil(sqrt(x));
      if s*(s-1) >= x
         sub = [x-1,x];
      else
         sub = [x,x];
      end
      current = 0;
   end
   fg = figure(varargin{:});
   setappdata(fg,'nextplot_sub',sub);
   setappdata(fg,'nextplot_current',current);
   setappdata(fg,'nextplot_figureProp',varargin);
   return
end   

fg = gcf();
sub = getappdata(fg,'nextplot_sub');
current = getappdata(fg,'nextplot_current');

if ~isnumeric(sub) || length(sub) ~= 2 ...
      || ~isnumericscalar(current)
   error('Cannot use NEXTPLOT in this figure.');
end

% Open a new figure if the number of subplots exceeds the maximum.
if current >= prod(sub)
   current = 0;
   figureProp = getappdata(fg,nextplot,'nextplot_figureProp');
   fg = figure(figureProp{:});
   setappdata(fg,'nextplot_sub',sub);
   setappdata(fg,'nextplot_current',current);
end

% Add new subplot to the current figure.
current = current + 1;
h = subplot(sub(1),sub(2),current);
setappdata(fg,'nextplot_current',current);

end
% End of primary function.
