function regexpparser(inputfile,outputfile,varargin)

p = irisparser(inputfile);
x = p.code;

% Remove keywords.
x = regexprep(x,'[@!][a-zA-Z]+(:[a-zA-Z]+)?','');

% Read all names except functions.
list = regexp(x,'\<[a-zA-Z]\w*\>(?!\()','match');
list = unique(list);

xlist = {};
ylist = {};
elist = {};
ulist = {};
plist = {};
loglist = {};
allbut = false;

for i = 1 : 2 : numel(varargin)
   if isempty(varargin{i+1})
      continue
   end
   tmp = regexp(list,['^(?:',varargin{i+1},')$']);
   index = ~cellfun(@isempty,tmp);
   switch lower(varargin{i})
      case {'x','variables:transition'}
         xlist = [xlist,list(index)];
      case {'y','variables:measurement'}
         ylist = [ylist,list(index)];
      case {'e','shocks:transition'}
         elist = [elist,list(index)];
      case {'u','shocks:measurement'}
         ulist = [ulist,list(index)];
      case {'p','parameters'}
         plist = [plist,list(index)];
      case {'log','allbut','variables:log','variables:log allbut'}
         if i+1 ~= numel(varargin)
            error('The variables:log section can be specified only at the end.');
         end
         tmplist = [xlist,ylist];
         tmp = regexp(tmplist,['^(?:',varargin{i+1},')$']);
         index = ~cellfun(@isempty,tmp);
         loglist = [loglist,tmplist(index)];
         index = [];
         allbut = ~isempty(strfind(lower(varargin{i}),'allbut'));
   end
   if ~isempty(index)
      list(index) = [];
   end
end

nl = sprintf('\n');
x = [ ...
   addsection('!variables:transition',xlist), ...
   addsection('!shocks:transition',elist), ...
   addsection('!parameters',plist), ...
   addsection('!variables:measurement',ylist), ...
   addsection('!shocks:measurement',ulist), ...
   ];

if allbut
   x = [x,addsection(sprintf('!variables:log\n   !allbut'),loglist)];
else
   x = [x,addsection('!variables:log',loglist)];
end

x = [x,nl,file2char(inputfile)];

char2file(x,outputfile);

end


function x = addsection(heading,list)
   nl = sprintf('\n');
   if ~isempty(list)
      rows = [nl,nl,'   '];
      for i = 1 : numel(list)
         rows = [rows,sprintf(list{i})];
         index = find(rows == nl,1,'last');
         if numel(rows) - index + 2 > 75
            rows = [rows,nl,'   '];
         elseif i < numel(list)
            rows = [rows,', '];
         end
      end
   else
      rows = '';
   end
   x = [heading,'   ',rows,nl,nl];
end