function str = strrepoutbrk(str,find,replace,varargin)
% STRREPOUTBRK  Replace substring outside brackets.

% The IRIS Toolbox 2009/09/01.
% Copyright 2007-2009 Jaromir Benes.

% Handle cellstr on input.
nstr = numel(str);
if iscellstr(str)
   for i = 1 : nstr
      str{i} = strrepoutbrk(str{i},find,replace,varargin{:});
   end
   return
end

%**************************************************************************
% Function body.

nfind = numel(find);
nbrk = numel(varargin);
brks = zeros([nbrk,nstr]);
for i = 1 : nbrk
   brks(i,strfind(str,varargin{i}{1})) = 1;
   brks(i,strfind(str,varargin{i}{2})) = -1;
end
outbrk = all(cumsum(brks,2) == 0,1);
index = strfind(str,find);
tmpreplace = char(zeros(size(find)));

for i = index
   if outbrk(i)
      str(i+(0:nfind-1)) = tmpreplace;
   end
end
str = strrep(str,tmpreplace,replace);

end
% End of primary function.